/* extends the launcher.js object with 
 * enhancements specific to showing the 
 * launcher inside the main ff browser 
 * window. 
 */

sitelauncherLauncher.gbrowser_init = function(e)
{
  sitelauncherLauncher.nodes.contextMenuItem = document.getElementById('sitelauncherContextMenuItem');

  if(sitelauncher.getBoolPref('extensions.sitelauncher.firstRun'))
  {
    // first time new defaults since 2.0.0
    sitelauncherLauncher.prefs.setBoolPref("extensions.sitelauncher.grouping", false);
    sitelauncherLauncher.prefs.setBoolPref("extensions.sitelauncher.launcher.lines", false);
    sitelauncherLauncher.prefs.setBoolPref("extensions.sitelauncher.urls.openAfterCurrentTab", true); 
    sitelauncherLauncher.prefs.setBoolPref("extensions.sitelauncher.launcher.showIconReflections", false);
    sitelauncherLauncher.prefs.setBoolPref("extensions.sitelauncher.launcher.roundedCorners", false);     
    
    sitelauncherLauncher.prefs.setCharPref("extensions.sitelauncher.launcher.color.background", "#000000");
    sitelauncherLauncher.prefs.setCharPref("extensions.sitelauncher.launcher.color.foreground", "#FFFFFF");
     
    sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.iconSize", 0);
    sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.keyDisplay", 1); 
    sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.columns", 3);
    sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.padding", 3);   
    sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.gradient", 1);       
    
    if(sitelauncherLauncher.OS === 'Darwin')
    {
      sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.shortcut.modifiers.primary", 2);
      sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.shortcut.modifiers.secondary", 3);
      
      // default hotkey is now ctrl + space for mac also
      //sitelauncherLauncher.prefs.setIntPref("extensions.sitelauncher.launcher.shortcut.modifiers.primary", 1);
    }
    
    try
    {
      var lang = sitelauncher.getCharPref('general.useragent.locale').split('-', 1)[0].toLowerCase();
      if(lang !== 'en')
      {
        sitelauncherLauncher.prefs.setBoolPref('extensions.sitelauncher.altGr', false);
      }
    }
    catch(e){}

    sitelauncherLauncher.prefs.setBoolPref('extensions.sitelauncher.firstRun', false);
  }

  if(sitelauncher.prefs.prefHasUserValue('extensions.sitelauncher.shortcutThisPage.key'))
  {
    var key = document.getElementById('sitelauncherKeyAddSite');
    key.setAttribute('key',
                     sitelauncher.getCharPref('extensions.sitelauncher.shortcutThisPage.key'));
  }
  
  if(sitelauncher.prefs.prefHasUserValue('extensions.sitelauncher.manageShortcuts.key'))
  {
    var key = document.getElementById('sitelauncherKeyManage');
    key.setAttribute('key',
                     sitelauncher.getCharPref('extensions.sitelauncher.manageShortcuts.key'));
  }
     
   
  var appcont = document.getElementById("appcontent"); 
  if(appcont)
  {
    appcont.addEventListener("DOMContentLoaded", sitelauncherLauncher.autoload, false);
  }  

  sitelauncherLauncher.setMenuItemVisibility();  
  
  document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", 
    function(e){sitelauncherLauncher.showContentContextMenuItem();}, false);
 
  sitelauncherLauncher.setLauncherButtonTooltip();  
};

sitelauncherLauncher.showContentContextMenuItem = function()
{
  try
  {
    if(!gContextMenu.onLink || !sitelauncher.getBoolPref("extensions.sitelauncher.showContextMenuItems"))
    {
      sitelauncherLauncher.nodes.contextMenuItem.setAttribute('hidden', 'true');
    }
    else
    {
      sitelauncherLauncher.nodes.contextMenuItem.removeAttribute('hidden');
    }
  }
  catch(e){}
};

sitelauncherLauncher.addToolbarButton = function()
{
  try
  {
    var navbar = document.getElementById("nav-bar");
    var set = navbar.currentSet;
    if(set.indexOf("slLauncherToolbarButton") === -1)
    {
      var newSet = set + ",slLauncherToolbarButton"
           
      navbar.setAttribute("currentset", newSet);
      navbar.currentSet = newSet;
      document.persist("nav-bar", "currentset");

      try
      {
        BrowserToolboxCustomizeDone(true);
      }
      catch(e){}
    }
  }
  catch(e){}
};

sitelauncherLauncher.removeToolbarButton = function()
{
  try
  {
    var navbar = document.getElementById("nav-bar");
    var set = navbar.currentSet;
    if(set.indexOf("slLauncherToolbarButton") !== -1)
    {
      var newSet = set.replace(/[,]*slLauncherToolbarButton([,])*/, "$1");

      navbar.setAttribute("currentset", newSet);
      navbar.currentSet = newSet;
      document.persist("nav-bar", "currentset");

      try
      {
        BrowserToolboxCustomizeDone(true);
      }
      catch(e){}
    }
  }
  catch(e){}
};  

sitelauncherLauncher.autoload = function(e)
{
  if(gBrowser.selectedBrowser.currentURI.spec ===  'chrome://sitelauncher/content/home.html')
  {
    sitelauncherLauncher.mode = sitelauncherLauncher.modes.launcher;
    sitelauncherLauncher.show();
  }
};

sitelauncherLauncher.invokeLauncherFromButton = function(e)
{
  var button = document.getElementById("slLauncherToolbarButton");
  if(button)
  {
    var x = button.boxObject.screenX;
    var y = button.boxObject.screenY;
    var h = button.boxObject.height;
    var offset = sitelauncherLauncher.getFirstItemHorizOffset() - document.documentElement.boxObject.screenX;
    
    var targetX = x - offset;
    var targetY = y + h + offset / 2;
    
    sitelauncherLauncher.mode = sitelauncherLauncher.modes.launcher;
    sitelauncherLauncher.showLauncherAtPos(targetX, targetY);
  }  
};

sitelauncherLauncher.setMenuItemVisibility = function()
{
  var menu = document.getElementById("sitelauncherMenu");
  var show = sitelauncher.getBoolPref("extensions.sitelauncher.showMenu");
  
  if(show)
  {
    if(menu.hasAttribute('hidden'))
    {
      menu.removeAttribute('hidden');
    }
  }
  else
  {
    menu.setAttribute('hidden', true);
  }
};
  
sitelauncherLauncher.setLauncherButtonTooltip = function()
{
  // obsolete
  
  return;

  var slButton = document.getElementById("slLauncherToolbarButton");

  if(slButton !== null)
  {
    var keys = [sitelauncher.getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.secondary'),
                sitelauncher.getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.primary')];
                
    slButton.setAttribute('tooltiptext', sitelauncherUtilsMisc.getKeyComboAsLocaleText(keys));
  }
};

sitelauncherLauncher.gbrowser_handlePrefChange = function(name)
{
  switch(name)
  {
    case "extensions.sitelauncher.launcher.showOnStartup":
      if(sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.showOnStartup'))
      {
        sitelauncher.prefs.setCharPref('browser.startup.homepage',
          'chrome://sitelauncher/content/home.html');
        sitelauncher.prefs.setIntPref('browser.startup.page', 1);
      }
      else if(sitelauncherLauncher.prefAccessor.getCharPref('browser.startup.homepage') ===
        'chrome://sitelauncher/content/home.html')
      {
        sitelauncher.prefs.setCharPref('browser.startup.homepage', '');
      }
    break;
    break;
    case "extensions.sitelauncher.showMenu":
        sitelauncherLauncher.setMenuItemVisibility();
    break;
    case "extensions.sitelauncher.launcher.shortcut.modifiers.primary":
    case "extensions.sitelauncher.launcher.shortcut.modifiers.secondary":
        sitelauncherLauncher.setLauncherButtonTooltip();
    break;        
    case "extensions.sitelauncher.launcher.mouseSupport":
      if(sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.mouseSupport'))
      {
        sitelauncherPlugins.enable('mouseSupport');
      
        if(sitelauncherLauncher.nodes.panelMenuMouseLabel)
        {
          sitelauncherLauncher.nodes.panelMenuMouseLabel.setAttribute('value', sitelauncherUtilsMisc.getLocaleString("turnOffMouseSupport"));
        }
      }
      else
      {
        sitelauncherPlugins.disable('mouseSupport');
        
        if(sitelauncherLauncher.nodes.panelMenuMouseLabel)
        {
          sitelauncherLauncher.nodes.panelMenuMouseLabel.setAttribute('value', sitelauncherUtilsMisc.getLocaleString("turnOnMouseSupport")); 
        }          
      }
    break;   
    case "extensions.sitelauncher.showToolbarButton":
      var showButton = sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.showToolbarButton');
      
      if(showButton)
      {
        sitelauncherLauncher.addToolbarButton();
      }
      else
      {
        sitelauncherLauncher.removeToolbarButton();
      }
    break; 
  }
};

/* on launcher initialized inside gbrowser */
sitelauncherHooks.attach('launcherInitBefore', sitelauncherLauncher.gbrowser_init);

/* on sl pref change detected inside gbrowser */
sitelauncherHooks.attach('sitelauncherPrefChange', sitelauncherLauncher.gbrowser_handlePrefChange);

/* attach launcher listeners to window */
window.addEventListener("load", sitelauncherLauncher.init, false);
window.addEventListener('keydown', sitelauncherLauncher.listeners.keydown, true);