// Copyright (c) 2008-2012 Done Smart Ltd (donesmart.com)
//
// This software is property of Done Smart Ltd,
// do not redistribute any part of it without our
// permission.
var sitelauncherLauncher = 
{
  readOnly : false,
  prefs : null,
  modes : {idle     : 0,
           launcher : 1,
           shortcut : 2},
  mode : 0,
  IDLEMODE: 0,
  modifiers : [-1, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_ALT,
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_CONTROL,
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_SHIFT, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_META, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_BACK_SPACE, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_CAPS_LOCK,          
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_DELETE, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_DOWN, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_END,  
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_ENTER, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_ESCAPE, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F1, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F2,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F3,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F4,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F5,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F6,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F7,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F8,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F9,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F10,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F11,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F12,          
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F13,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F14,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F15,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F16,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F17,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F18,         
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_F19,
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_HOME,  
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_INSERT, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_LEFT, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_NUM_LOCK, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_PAGE_DOWN, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_PAGE_UP, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_PAUSE, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_PRINTSCREEN,     
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_RIGHT, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_SCROLL_LOCK,  
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_SPACE, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_TAB, 
               Components.interfaces.nsIDOMKeyEvent.DOM_VK_UP,
               91], // winkey 
               
  fontSizes : ['small','medium','large'],
  nodes : {},
  screenX : 0,
  screenY : 0,
  width : 0,
  height : 0,
  launcherHashTables : null,
  launcherHotKeyDown : false,
  orientationTypes : {'horizontal' : 0, 
                      'vertical' : 1,
                      'newspaper' : 2},
  columnWidths : {'narrow' : 0,
                  'medium' : 1,
                  'wide' : 2},
  columnWidthEm : 4, 
  prefAccessor : null,
  scrollbarVisible : false,
  horizScrollbarVisible : false,
  keyDisplayStates : {'left' : 0,
                      'right' : 1, 
                      'hide' : 2},             
  ESCAPE_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_ESCAPE,
  TAB_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_TAB,
  SHIFT_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_SHIFT,
  CTRL_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_CONTROL,
  ALT_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_ALT,
  META_KEY : Components.interfaces.nsIDOMKeyEvent.DOM_VK_META,

  _launcherHotkeyAsArray : null,
  _DTSHotkeyAsArray : null,  

  init : function()
  {
    sitelauncher.init(); // init ignored if already called

    /* assign sub objects */

    sitelauncherLauncher.nodes.base = document.getElementById('sitelauncherBox');
    sitelauncherLauncher.nodes.rows = document.getElementById('sitelauncherBoxRows');
    sitelauncherLauncher.nodes.columns = document.getElementById('sitelauncherBoxColumns');
    sitelauncherLauncher.nodes.canvasFrame = document.getElementById('sitelauncherCanvasFrame');
    sitelauncherLauncher.nodes.bufferFrame = document.getElementById('sitelauncherBufferFrame');
    sitelauncherLauncher.nodes.panel = document.getElementById('sitelauncherPanel');
    sitelauncherLauncher.nodes.panelMenuMouseLabel = null;
    
    sitelauncherLauncher.prefs =
      Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    sitelauncherLauncher.OS =
      Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
      
    sitelauncherLauncher.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
    sitelauncherLauncher.prefs.addObserver("", sitelauncherLauncher, false);          
      
    sitelauncherLauncher.prefAccessor = sitelauncher;
                           
    sitelauncherLauncher.launcherHashTables = new SitelauncherHashTables();
    
    sitelauncherHooks.fire('launcherInitBefore', true);    

    sitelauncherLauncher.loadShortcutData();    

    sitelauncherPlugins.init(); 

    sitelauncherLauncher.update();
    sitelauncherLauncher.buffer();

    sitelauncherLauncher.nodes.base.addEventListener('mousedown', 
      function(e)
      { 
        if(sitelauncherLauncher.menu.isActive() || e.button === 2)
        {
          e.stopPropagation(); 
          e.preventDefault();
          sitelauncherLauncher.menu.toggle();
        }
        
        return false;
      }, false); 
      
    sitelauncherLauncher.nodes.base.addEventListener('DOMMouseScroll', 
      function(e)
      {
        var scrollAxisHoriz = false;
        
        if(typeof e.axis !== "undefined") // e.axis undefined prior firefox 3.5
        {
          if(e.axis === e.HORIZONTAL_AXIS)
          {
            scrollAxisHoriz = true;
          }
        }
        
        var xpcomInterface = sitelauncherLauncher.nodes.base.boxObject.QueryInterface(
             Components.interfaces.nsIScrollBoxObject);
       
        /* void scrollBy(in long dx, in long dy);
        void scrollByLine(in long dlines);
        void scrollByIndex(in long dindexes);
        void scrollToLine(in long line);
        void scrollToElement(in nsIDOMElement child);
        void scrollToIndex(in long index); */   
                
        var mouseTicks = e.detail;
        
        if(sitelauncherLauncher.scrollbarVisible && !scrollAxisHoriz)
        {
          // note: mouseTicks & scrollByLine both use negative int 
          // for up scroll ticks and positive for down 
          xpcomInterface.scrollByLine(mouseTicks);
        }
        else if(sitelauncherLauncher.horizScrollbarVisible)
        {
          var xScrollOffset = !scrollAxisHoriz ? mouseTicks * -1 * 30 : mouseTicks * 30;
          xpcomInterface.scrollBy(xScrollOffset, 0); 
        }
      }, false);
      
    if(sitelauncherLauncher.OS === 'Darwin')
    {
      sitelauncherLauncher.nodes.base.addEventListener('mouseover', function(e){
        if(!sitelauncherLauncher.menu.isActive())
          return;
        
          var items = sitelauncherPanels.panels['sitelauncherLauncherMenuBox'].ref.
                        getElementsByTagName('hbox');
          
          var sel = false;        
          for(var x = 0; x < items.length; x++)
          {
            if(!sel && e.screenY < items[x].boxObject.screenY)
            {
              items[x].setAttribute('class', 'selected');
              sel = true;
              continue;
            }
            items[x].setAttribute('class', '');
          }     
  
      }, false);
    }
    
    sitelauncherLauncher._launcherHotkeyAsArray =  sitelauncherLauncher._getLauncherHotkeyAsArray();
    sitelauncherLauncher._DTSHotkeyAsArray = sitelauncherLauncher._getDTSHotkeyAsArray();  
      
    // global launcher, shortcut event listeners
    window.addEventListener("keypress",  sitelauncherLauncher.key, true); 
    window.addEventListener('keyup', sitelauncherLauncher.listeners.keyup, false);

    sitelauncherHooks.fire('launcherInitAfter', true);  
  },
  
  loadShortcutData : function()
  {
    if(!sitelauncherLauncher.readOnly) 
    {
      sitelauncher.setRequiredIconSize(sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.iconSize'));
      sitelauncher.load();
    }
  },
  
  invokeLauncherMode : function(e)
  {
    sitelauncherLauncher.mode = sitelauncherLauncher.modes.launcher;
    sitelauncherLauncher.show();
  },
  
  determineColumnWidths : function()
  {
    var columnWidth = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columnWidth');

    if(sitelauncherLauncher.columnWidths.narrow === columnWidth)
    {
      sitelauncherLauncher.columnWidthEm = 4.2;
    }
    else if(sitelauncherLauncher.columnWidths.medium === columnWidth)
    {
      sitelauncherLauncher.columnWidthEm = 8;
    }
    else if(sitelauncherLauncher.columnWidths.wide === columnWidth)
    {
      sitelauncherLauncher.columnWidthEm = 14;
    }
  }, 
  
  getFirstItemHorizOffset : function()
  {
    var offset, slBoxClone;
    try
    {
      slBoxClone = sitelauncherLauncher.nodes.bufferFrame.contentDocument.getElementById('sitelauncherBox');
      offset = slBoxClone.getElementsByAttribute('class', 'sitelauncherIcon')[0].boxObject.screenX;
    }
    catch(e)
    {
      offset = 0;
    }
    
    return offset;  
  },
  
  buffer : function()
  {
    var nodes = sitelauncherLauncher.nodes;
    
    nodes.panel.parentNode.removeChild(nodes.panel);

    // rebuilding prevents flashes of old paint
    var popup = document.createElement('popup');
    popup.setAttribute('id', 'sitelauncherPanel');
    popup.setAttribute('ignorekeys', 'true');
    popup.setAttribute('noautofocus', 'true');
    popup.setAttribute('noautohide', 'true');        
    popup.addEventListener('popuphiding', function(e){sitelauncherLauncher.release(); return true;}, false); 
    document.documentElement.appendChild(popup);  
    nodes.panel = popup;    
    
    var x = 0;
    var boxes = nodes.base.getElementsByTagName('row');
    var hex = sitelauncherLauncher.prefAccessor.getCharPref('extensions.sitelauncher.launcher.lines.color');
    var rule = 'solid rgb(' + parseInt(hex.substring(1,3),16) + ',' + 
                              parseInt(hex.substring(3,5),16) + ',' + 
                              parseInt(hex.substring(5,7),16) + ')';

    for(x = 1; x < boxes.length; x++)
    {
      boxes[x].style.setProperty('border-top', 
        sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.lines') ? '1px ' + rule : 
        '0px ' + rule, null);
    }
  
    if(!sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.showIconReflections'))
    {
      nodes.base.setAttribute('class', 'hideReflections');
    }
    else
    {
      nodes.base.removeAttribute('class');
    }

    boxes = nodes.base.getElementsByTagName('hbox');
    var padding = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.padding');
    var innerPadding = Math.round(padding / 3 * 100) / 100;
    nodes.base.style.setProperty('padding', padding + 'em', null);
    var refl = sitelauncherLauncher.prefAccessor.getBoolPref("extensions.sitelauncher.launcher.showIconReflections");
    
    if(sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.grouping'))
    {
      for(x = 0; x < boxes.length; x++)
      {
        boxes[x].style.setProperty('padding', innerPadding + 'em', null);

        if(boxes[x].hasAttribute("sitelauncherGroupHeader"))
        {
          boxes[x].style.setProperty('-moz-box-align', 'end', null);   
          boxes[x].style.setProperty('padding-bottom', Math.round(innerPadding * 0.5 * 100) / 100 + 'em', null);
          
          if(x !== 0 & sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.orientation') !== 
                         sitelauncherLauncher.orientationTypes.vertical)
          {
            boxes[x].style.setProperty('padding-top', Math.round(innerPadding * 1.5 * 100) / 100 + 'em', null); 
          }
        }
      }
    }
    else
    {
      for(x = 0; x < boxes.length; x++)
      {
        boxes[x].style.setProperty('padding', innerPadding + 'em', null);
      }
    }
    
    // remove any previously fixed dimensions as we wish to expand to fit content 
    nodes.base.style.removeProperty("height");
    nodes.base.style.removeProperty("width"); 
 
    var fontSize = sitelauncherLauncher.fontSizes[
      sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.fontSize')];
    nodes.base.style.setProperty('font-size', fontSize, '');
    
    nodes.base.style.setProperty('color',
      sitelauncherLauncher.prefAccessor.getCharPref('extensions.sitelauncher.launcher.color.foreground'), '');    

    var iframeDoc = sitelauncherLauncher.nodes.bufferFrame.contentDocument;
    var boxElm = iframeDoc.getElementById('sitelauncherBox');
    if(boxElm)
    {
      boxElm.parentNode.removeChild(boxElm);
    }
    
    var clone = iframeDoc.importNode(nodes.base, true);
   
    iframeDoc.getElementById('container').appendChild(clone);

    sitelauncherLauncher.width = parseInt(clone.boxObject.width, 10);
    sitelauncherLauncher.height = parseInt(clone.boxObject.height, 10);
    
    // limit height to that of screen
    var docHeight = parseInt(window.screen.availHeight) - 40 /* a bit of padding for good measure */;
    var launcherHeight = sitelauncherLauncher.height;
    
    // limit width to that of screen
    var docWidth = parseInt(window.screen.availWidth)  - 10;
    var launcherWidth = sitelauncherLauncher.width;
    
    if(launcherHeight > docHeight) 
    {
      sitelauncherLauncher.height = docHeight;
      nodes.base.style.setProperty("height", docHeight + "px", null);
      sitelauncherLauncher.scrollbarVisible = true;
      sitelauncherLauncher.width += 23; // allow space for scrollbar (todo: determine exact scrollbar width dynamically)
      nodes.base.style.setProperty("width", sitelauncherLauncher.width + "px", null);
    }
    else 
    {
      sitelauncherLauncher.scrollbarVisible = false;      
    }
    
    if(launcherWidth > docWidth)
    {
      sitelauncherLauncher.width = docWidth;
      nodes.base.style.setProperty("width", docWidth + "px", null);
      sitelauncherLauncher.horizScrollbarVisible = true;
      sitelauncherLauncher.height += 23; // allow space for scrollbar (todo: determine exact scrollbar width dynamically)
      nodes.base.style.setProperty("height", sitelauncherLauncher.height + "px", null);
    }
    else
    {
      sitelauncherLauncher.horizScrollbarVisible = false;
    }
    
    sitelauncherLauncher.updateBackground();
    
    // handle other panels
    if(sitelauncherPanels.exists('sitelauncherLauncherMenuBox'))
    {
      sitelauncherPanels.setMinWidth('sitelauncherLauncherMenuBox', sitelauncherLauncher.width - 60);
    }
    sitelauncherPanels.bufferAll();
    
    nodes.panel.appendChild(nodes.base);
  },
  
  observe : function(subject, topic, data)
  {
    if(topic === "nsPref:changed" && /^extensions\.sitelauncher/.test(data))
    {
      try
      {
        sitelauncher.prefValues[data] = null;
        sitelauncherLauncher.handlePrefChange(data);
      }
      catch(e)
      {
      }
    }
  },    
  
  handlePrefChange : function(name)
  {
    switch(name)
    {
      case "extensions.sitelauncher.launcher.columns":
      case "extensions.sitelauncher.launcher.orientation":      
      case "extensions.sitelauncher.launcher.showIconReflections":  
      case "extensions.sitelauncher.launcher.boldHeaders":      
      case "extensions.sitelauncher.launcher.keyDisplay":         
      case "extensions.sitelauncher.launcher.columnWidth":  
        sitelauncherLauncher.update();
        sitelauncherLauncher.buffer();
      break;
      case "extensions.sitelauncher.launcher.color.background":
      case "extensions.sitelauncher.launcher.opacity":
      case "extensions.sitelauncher.launcher.roundedCorners":
      case "extensions.sitelauncher.launcher.fontSize":
      case "extensions.sitelauncher.launcher.gradient":
      case "extensions.sitelauncher.launcher.lines":
      case "extensions.sitelauncher.launcher.padding":
      case "extensions.sitelauncher.launcher.lines.color":
      case "extensions.sitelauncher.launcher.border":     
      case "extensions.sitelauncher.launcher.color.foreground":
        sitelauncherLauncher.buffer();
      break;
      case "extensions.sitelauncher.modified":
      case "extensions.sitelauncher.grouping":
      case "extensions.sitelauncher.launcher.iconSize":        
        sitelauncherLauncher.loadShortcutData();    
        sitelauncherLauncher.update();
        sitelauncherLauncher.buffer();
      break;
    }
    
    // handle hotkey(s) pref change
    sitelauncherLauncher._launcherHotkeyAsArray =  sitelauncherLauncher._getLauncherHotkeyAsArray();
    sitelauncherLauncher._DTSHotkeyAsArray = sitelauncherLauncher._getDTSHotkeyAsArray();  
    
    sitelauncherHooks.fire('sitelauncherPrefChange', name);
  },  
  
  getItemIconById : function(id)
  {
    return sitelauncherLauncher.launcherHashTables.get('itemIconById', id);
  },
  
  update : function()
  {
    sitelauncherUtilsDom.deleteAllChildNodes(sitelauncherLauncher.nodes.rows);
    sitelauncherUtilsDom.deleteAllChildNodes(sitelauncherLauncher.nodes.columns);    
    
    sitelauncherLauncher.launcherHashTables.clearAll();
    
    sitelauncherLauncher.determineColumnWidths();

    var class_list = "";

    if(sitelauncherLauncher.prefAccessor.getBoolPref("extensions.sitelauncher.launcher.boldHeaders")) 
    {
      class_list += " bold_group_headers ";
    }
    
    var key_state = sitelauncherLauncher.prefAccessor.getIntPref("extensions.sitelauncher.launcher.keyDisplay");
    
    if(key_state === sitelauncherLauncher.keyDisplayStates.left)
    {
      class_list += " show_keys_left ";
    }    
    else if(key_state === sitelauncherLauncher.keyDisplayStates.right)
    {
      class_list += " show_keys_right ";
    }
    else if(key_state === sitelauncherLauncher.keyDisplayStates.hide) 
    {
      class_list += " dont_show_keys ";
    }

    // class enabled appearance settings
    sitelauncherLauncher.nodes.base.setAttribute("__enabled_settings", class_list);   
  
    var numCols = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columns'); 
    
    // create columns
    for(var x = 0; x < numCols; x++)
    {
      var col = document.createElement('column');
      sitelauncherLauncher.nodes.columns.appendChild(col);
    }    
    
    if(!sitelauncherLauncher.prefAccessor.getBoolPref("extensions.sitelauncher.grouping"))
    {
      sitelauncherLauncher.updateNoGrouping();
    }
    else if(sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.orientation') === 
            sitelauncherLauncher.orientationTypes.horizontal)
    {
      sitelauncherLauncher.updateGroupsHorizontal();
    }
    else if(sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.orientation') === 
            sitelauncherLauncher.orientationTypes.newspaper)
    {
      sitelauncherLauncher.updateGroupsNewspaperStyle();
    }
    else
    {
      sitelauncherLauncher.updateGroupsVertical();
    }
    
    sitelauncherPlugins.fire('launcherLinksUpdated', 1, sitelauncherLauncher.nodes.base);

    if(sitelauncher.shortcutSchemaVersion < 2 && 
       sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.iconSize') !== 1)
    {
      sitelauncherSiteIconDataMigrator.migrateAllSiteIcons();
    }    
  },
  
  updateNoGrouping : function()
  {
    var numCols = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columns');     
    var sites = sitelauncher.sites;
    var row = document.createElement('row');
    for(var x = 0; x < sites.length; x++)
    {
      row.appendChild(sitelauncherLauncher.createItem(sites[x]));
     
      if((x + 1) % numCols === 0 || x + 1 === sites.length)
      {
        sitelauncherLauncher.nodes.rows.appendChild(row);
        row = document.createElement('row');
      }
    }
  },
  
  updateGroupsHorizontal : function()
  {
    var groups = sitelauncher.groups;
    for(var i = 0; i < sitelauncher.groups.length; i++)
    {
      sitelauncherLauncher.createHorizontalGrouping(sitelauncher.groups[i]);
    }    
  },
  
  updateGroupsVertical : function()
  {
    var numCols = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columns');     
    var groups = sitelauncher.groups;
    var nonEmptyGroupCount = 0;
    var row = document.createElement('row');
    for(var i = 0; i < groups.length; i++)
    {
      var box = sitelauncherLauncher.createVerticalGrouping(groups[i]);
      
      if(box !== null)
      {
        row.appendChild(box);
        nonEmptyGroupCount++;
      }

      // (close row at column limit) || close row if reached end 
      if((nonEmptyGroupCount !== 0 && nonEmptyGroupCount % numCols === 0) || i + 1 === groups.length)
      {
        sitelauncherLauncher.nodes.rows.appendChild(row);
        row = document.createElement('row');
      }
    }
  },
  
  updateGroupsNewspaperStyle : function()
  {
    var numCols = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columns');     
    var groups = sitelauncher.groups;
    var totalNumItems = 0;
    var allItems = [];
    
    for(var i = 0; i < groups.length; i++)
    {
      var group = groups[i];
     
      var sitesInGroup = sitelauncher.getSitesByGroup(group.id);

      if(sitesInGroup.length > 0)
      {
        allItems[totalNumItems++] = {'id' : group.id, 'title': group.title, 'isGroup' : true};
        
        for(x = 0; x < sitesInGroup.length; x++)
        {
          allItems[totalNumItems++] = sitesInGroup[x];
        }
      }
    }
    
    if(totalNumItems === 0)
    {
      return;
    }
    
    var itemsPerCol = Math.ceil(totalNumItems / numCols);
    
    var row = document.createElement('row');
    var box = document.createElement('vbox');
    
    for(var i = 0; i < totalNumItems; i++)
    {
      if(allItems[i].isGroup)
      {
        var group = allItems[i];
        var hbox = document.createElement('hbox');
        hbox.setAttribute('sitelauncherGroupHeader', 'true');
        
        var groupTitleBox = document.createElement("vbox");    
        
        var label = sitelauncherUtilsDom.createLabel(group.title,
                      {'class': 'sitelauncherGroupLabel',
                       'crop': 'end'});
        
        label.style.setProperty('max-width', (sitelauncherLauncher.columnWidthEm + 2) + "em", null); 
        
        groupTitleBox.appendChild(label);
        hbox.appendChild(groupTitleBox);
          
        box.appendChild(hbox);
      }
      else
      {
        var item = sitelauncherLauncher.createItem(allItems[i]);
        box.appendChild(item);
      }

      // close box/column if reached item limit or end
      if((i + 1) % itemsPerCol === 0 || i + 1 === totalNumItems)
      {
        row.appendChild(box);
        box = document.createElement('vbox');
      }
    }
    
    sitelauncherLauncher.nodes.rows.appendChild(row);
  },  
  
  createHorizontalGrouping : function(group)
  {
    var sites = sitelauncher.getSitesByGroup(group.id);
        
    if(sites.length === 0)
    {
      return null;
    }
    
    var numCols = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.columns');

    var row = document.createElement('row');
    row.setAttribute('class', 'sitelauncherGroupRow');
    var hbox = document.createElement('hbox');
    hbox.setAttribute('sitelauncherGroupHeader', 'true');
    
    var groupTitleBox = document.createElement("vbox");    
    
    var label = sitelauncherUtilsDom.createLabel(group.title,
                  {'class': 'sitelauncherGroupLabel',
                   'crop': 'end'});
    
    label.style.setProperty('max-width', (sitelauncherLauncher.columnWidthEm + 2) + "em", null); 
    
    groupTitleBox.appendChild(label);
    hbox.appendChild(groupTitleBox);
      
    row.appendChild(hbox);
    sitelauncherLauncher.nodes.rows.appendChild(row);      
    
    row = document.createElement('row');
    for(var x = 0; x < sites.length; x++)
    {
      row.appendChild(sitelauncherLauncher.createItem(sites[x]));
       
      if((x + 1) % numCols === 0 || x + 1 === sites.length)
      {
        sitelauncherLauncher.nodes.rows.appendChild(row);
        row = document.createElement('row');
      }
    }
  },  
  
  createVerticalGrouping : function(group)
  {
    var sites = sitelauncher.getSitesByGroup(group.id);
    if(sites.length === 0)
    {
      return null;
    }
    
    // header span elm
    var vbox = document.createElement('vbox');
    var hbox = document.createElement('hbox');
    hbox.setAttribute('sitelauncherGroupHeader', 'true');
        
    var groupTitleBox = document.createElement("vbox");            
        
    var label = sitelauncherUtilsDom.createLabel(group.title, 
      {'class': 'sitelauncherGroupLabel',
       'crop': 'end'});

    label.style.setProperty('max-width', (sitelauncherLauncher.columnWidthEm + 2) + "em", null); 
    
    if(sitelauncherLauncher.prefAccessor.getBoolPref("extensions.sitelauncher.launcher.boldHeaders"))
    {
      label.style.setProperty('font-weight', 'bold', null);
    }      
    
    groupTitleBox.appendChild(label);
    hbox.appendChild(groupTitleBox);    
    
    vbox.appendChild(hbox);

    hbox = document.createElement('vbox');
    hbox.setAttribute('align', 'start');
    var box = document.createElement('vbox');
    for(var x = 0; x < sites.length; x++)
    {
      box.appendChild(sitelauncherLauncher.createItem(sites[x]));
    }
    hbox.appendChild(box);
    vbox.appendChild(hbox);
        
    return vbox;
  },
  
  createItem : function(site)
  {
    var hbox = document.createElement('hbox');
    hbox.setAttribute('__slItemId', site.id);    

    // key label    
    
    var key_state = sitelauncherLauncher.prefAccessor.getIntPref("extensions.sitelauncher.launcher.keyDisplay");

    var keyLabel = sitelauncherUtilsDom.createLabel(site.key, {"class": 'sitelauncherKeyLabel'});

    if(key_state === sitelauncherLauncher.keyDisplayStates.left)
    {
      hbox.appendChild(keyLabel);
    }
    
    // shortcut icon
    
    var img = document.createElement('box');
    img.setAttribute('class', 'sitelauncherIcon');
    
    var icon_src = sitelauncherSiteIcons.getSiteIconBySize(site, sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.iconSize'));
    img.style.setProperty('background-image', 'url("' + icon_src + '")', '');
      
    var dimensions = sitelauncherSiteIcons.getSiteIconDimensionsWithAttributes(sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.iconSize'), sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.showIconReflections'));
      
    img.style.setProperty('width', dimensions[0] + 'px', null);
    img.style.setProperty('height', dimensions[1] + 'px', null);
    
    sitelauncherLauncher.launcherHashTables.insert('itemIconById', site.id, img);
    
    hbox.appendChild(img); 
    
    // shortcut title

    var shortcutTitleBox = document.createElement("vbox");
    
    var titleLabel = sitelauncherUtilsDom.createLabel(site.title, 
              {"class": "sitelauncherShortcutLabel",
               "style": "opacity: .7",
               "crop": "end"});
    
    titleLabel.style.setProperty('max-width', sitelauncherLauncher.columnWidthEm + "em", null); 
    
    shortcutTitleBox.appendChild(titleLabel);
    
    hbox.appendChild(shortcutTitleBox);
    
    // key label (if right display)
    if(key_state === sitelauncherLauncher.keyDisplayStates.right)
    {
      shortcutTitleBox.setAttribute("flex", "2");

      hbox.appendChild(keyLabel);
    }    
    
    return hbox;
  },  
  
  show : function()
  {
    if(sitelauncherLauncher.mode === sitelauncherLauncher.modes.launcher)
    {
      var x = (parseInt(document.width, 10) / 2) - (parseInt(sitelauncherLauncher.width, 10) / 2);
      var y = (parseInt(document.height, 10) / 2) - (parseInt(sitelauncherLauncher.height, 10) / 2);

      // adjust for desktop offset
      x += document.documentElement.boxObject.screenX;
      y += document.documentElement.boxObject.screenY;

      sitelauncherLauncher.showLauncherAtPos(x, y);
    }
  },
  
  showLauncherAtPos : function(x, y)
  {
    sitelauncherLauncher.screenX = x;
    sitelauncherLauncher.screenY = y;
    // per suggestion at https://developer.mozilla.org/en/DOM/document.popupNode - set document.popupNode
    // to null to indicate popup not associated with any specific dom target 
    document.popupNode = null; 
    sitelauncherLauncher.nodes.panel.showPopup(document.documentElement, x, y, 'context', null, null);
  },
    
  hide : function()
  { 
    sitelauncherLauncher.nodes.panel.hidePopup();
    sitelauncherLauncher.release();
  },

  release : function()
  {
    sitelauncherLauncher.mode = sitelauncherLauncher.modes.idle;
    sitelauncherLauncher.menu.release();
  },
  
  key : function(e)
  {
    if(sitelauncherLauncher.mode === sitelauncherLauncher.IDLEMODE)
    {
      // ignore - key event does not belong to launcher
      return;
    }
    
    e.preventDefault();
    e.stopPropagation();    
    
    if(e.keyCode === sitelauncherLauncher.ESCAPE_KEY && !sitelauncherLauncher.launcherHotKeyDown)
    {
      sitelauncherLauncher.hide();
    }
    else if(e.keyCode === sitelauncherLauncher.TAB_KEY)
    {
      if(sitelauncherLauncher.modifiers[
           sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.primary')] !==
             sitelauncherLauncher.TAB_KEY)
      {
        sitelauncherLauncher.menu.toggle();
      }
    }    
    else
    {
      sitelauncherLauncher.launchItemByKey(String.fromCharCode(e.which));
    }   
    
    // handle menu
    if(sitelauncherLauncher.menu.isActive())
    {
      sitelauncherLauncher.menu.handleKeyPress(e);
    }

    return false;
  },
  
  launchItemByKey : function(key)
  {
    sitelauncherLauncher.launchItem(sitelauncher.getSiteByKey(key, true));
  },
  
  launchItemById : function(id, forceNewTab)
  {
    sitelauncherLauncher.launchItem(sitelauncher.getSiteById(id), forceNewTab);
  },
  
  launchItem : function(site, forceNewTab)
  {
    if(!site)
    {
      return;
    }

    if(sitelauncherLauncher.mode === sitelauncherLauncher.modes.launcher)
    {
      sitelauncherLauncher.mode = sitelauncherLauncher.modes.idle;
      sitelauncherLauncher.indicateItemPressed(site.id);
    }
    else
    {
      sitelauncherLauncher.mode = sitelauncherLauncher.modes.idle;  
    }        
    
    sitelauncherLauncher.loadShorcutsURI(site, forceNewTab);      
  },
  
  loadShorcutsURI : function(site, forceNewTab)
  {
    var currentBrowser = gBrowser.selectedBrowser;
    var currentURI = currentBrowser.currentURI.spec;
    if(site.type !== sitelauncher.linkTypes.javascript && site.type !== sitelauncher.linkTypes.search &&
       (sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.urls.forceNewTab') || forceNewTab) && 
       ((currentURI !== 'about:blank' && currentURI !== 'chrome://sitelauncher/content/home.html') || 
         currentBrowser.webProgress.isLoadingDocument))
    {
      if(site.type === sitelauncher.linkTypes.standard)
      {
        if(!sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.urls.openAfterCurrentTab'))
        {
          gBrowser.selectedTab = gBrowser.loadOneTab(site.url);
        }
        else
        {
          var newIndex = gBrowser.tabContainer.selectedIndex + 1;
          var newTab = gBrowser.loadOneTab(site.url);
          gBrowser.moveTabTo(newTab, newIndex);
          gBrowser.selectedTab = newTab;
        }
      }
      else
      {
        var urls = site.url.split('|');
        
        if(!sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.urls.openAfterCurrentTab'))
        {
          gBrowser.selectedTab = gBrowser.loadOneTab(urls[0]);
          for (var x = 1; x < urls.length; x++)
          {
            gBrowser.loadOneTab(urls[x]);
          }
        }
        else
        {
          var newIndex = gBrowser.tabContainer.selectedIndex + 1;
          var firstNewTab = gBrowser.loadOneTab(urls[0]);
          gBrowser.moveTabTo(firstNewTab, newIndex);
          for (var x = 1; x < urls.length; x++)
          {
            gBrowser.moveTabTo(gBrowser.loadOneTab(urls[x]), ++newIndex);
          }
          gBrowser.selectedTab = firstNewTab;
          
        }
                
      }
    }
    else
    {
      if(site.type === sitelauncher.linkTypes.standard)
      {
        if(currentURI === 'about:blank')
        {
          currentBrowser.focus();
        }
        currentBrowser.loadURI(site.url);
      }
      else if(site.type === sitelauncher.linkTypes.javascript)
      {
        currentBrowser.webNavigation.loadURI(
          site.url, 
          Components.interfaces.nsIWebNavigation.LOAD_FLAGS_ALLOW_POPUPS,
          null, null, null);
      }
      else if(site.type === sitelauncher.linkTypes.multi)
      {
        gBrowser.loadTabs(site.url.split('|'), false, true);
      }
      else if(site.type === sitelauncher.linkTypes.search)
      {
        try
        {
          var url = site.url.split('search:', 2)[1];  
        }
        catch(e)
        {
          return;
        }

        sitelauncherSearchBox.setURL(url);
        sitelauncherSearchBox.setIcon(sitelauncherSiteIcons.getSiteIcon(site));
        sitelauncherSearchBox.show();
      }
    }
  },
  
  menu : 
  {
    listItems : null,
    selectedListItem : null,

    isActive : function(e)
    {
      return sitelauncherPanels.isShowing('sitelauncherLauncherMenuBox');
    },
   
    toggle : function(e)
    {
      if(!sitelauncherPanels.exists('sitelauncherLauncherMenuBox'))
      {
        sitelauncherLauncher.menu.listItems = [];
        sitelauncherLauncher.menu.selectedListItem = null; 
        var x = 0;

        var vbox = document.createElement('vbox');
        
        var fontSize = sitelauncherLauncher.fontSizes[
          sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.fontSize')];
        vbox.style.setProperty('font-size', fontSize, '');        
    
        var listitem = document.createElement('hbox');
        listitem.setAttribute('class', 'selected');
        listitem.setAttribute('value', 1);
        listitem.setAttribute('align', 'center');
        listitem.style.setProperty('padding', '0.2em', null);        
        listitem.style.setProperty('margin', '1px 1px 0 1px', null);   
        listitem.addEventListener('mouseover', sitelauncherLauncher.menu.mouseOver, false);  
        listitem.addEventListener('click', function(e){
          sitelauncherLauncher.hide();
          sitelauncherUtilsMisc.showPrefManageView();}, false);  
        var label = sitelauncherUtilsDom.createLabel(sitelauncherUtilsMisc.getLocaleString("manageMyShortcuts"));
        listitem.appendChild(label);
        vbox.appendChild(listitem);
        sitelauncherLauncher.menu.listItems[x++] = listitem;
        
        listitem = document.createElement('hbox');
        listitem.setAttribute('value', 1);
        listitem.setAttribute('align', 'center');
        listitem.style.setProperty('padding', '0.2em', null);        
        listitem.style.setProperty('margin', '1px 1px 0 1px', null);   
        listitem.addEventListener('mouseover', sitelauncherLauncher.menu.mouseOver, false);  
        listitem.addEventListener('click', function(e){
          sitelauncherLauncher.hide();
          sitelauncherUtilsMisc.showPrefShortcutPageView();}, false);  
        var label = sitelauncherUtilsDom.createLabel(sitelauncherUtilsMisc.getLocaleString("shortcutCurrentPage"));
        listitem.appendChild(label);
        vbox.appendChild(listitem);
        sitelauncherLauncher.menu.listItems[x++] = listitem;        

        listitem = document.createElement('hbox');
        listitem.setAttribute('value', 0);
        listitem.setAttribute('align', 'center');
        listitem.style.setProperty('padding', '0.2em', null);        
        listitem.style.setProperty('margin', '0 1px', null);        
        listitem.addEventListener('mouseover', sitelauncherLauncher.menu.mouseOver, false);  
        listitem.addEventListener('click', function(e){
          if(sitelauncherPlugins.enabled.indexOf('mouseSupport') === -1)
          {
            sitelauncher.prefs.setBoolPref('extensions.sitelauncher.launcher.mouseSupport', true);
            sitelauncherLauncher.menu.hide();
          }
          else
          {
            sitelauncher.prefs.setBoolPref('extensions.sitelauncher.launcher.mouseSupport', false);
            sitelauncherLauncher.menu.hide();          
          }
        }, false);
        label = sitelauncherUtilsDom.createLabel(sitelauncherPlugins.enabled.indexOf('mouseSupport') === -1 ? 
          sitelauncherUtilsMisc.getLocaleString("turnOnMouseSupport") : sitelauncherUtilsMisc.getLocaleString("turnOffMouseSupport"));
        listitem.appendChild(label);
        vbox.appendChild(listitem);    
        sitelauncherLauncher.menu.listItems[x++] = listitem;
        
        sitelauncherLauncher.nodes.panelMenuMouseLabel = label;
    
        listitem = document.createElement('hbox');
        listitem.setAttribute('value', 2);
        listitem.setAttribute('align', 'center'); 
        listitem.style.setProperty('padding', '0.2em', null);        
        listitem.style.setProperty('margin', '0 1px', null);              
        listitem.addEventListener('mouseover', sitelauncherLauncher.menu.mouseOver, false);  
        label = sitelauncherUtilsDom.createLabel(!sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.showOnStartup') ? 
          sitelauncherUtilsMisc.getLocaleString("setLauncherAsHomepage") : sitelauncherUtilsMisc.getLocaleString("disableAsHomepage"));
        listitem.addEventListener('click', function(e){
          if(!sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.showOnStartup'))
          {
            sitelauncher.prefs.setBoolPref('extensions.sitelauncher.launcher.showOnStartup', true);
            sitelauncherLauncher.menu.hide();
            this.getElementsByTagName('label')[0].setAttribute('value', sitelauncherUtilsMisc.getLocaleString("disableAsHomepage"));
          }
          else
          {
            sitelauncher.prefs.setBoolPref('extensions.sitelauncher.launcher.showOnStartup', false);
            sitelauncherLauncher.menu.hide();
            this.getElementsByTagName('label')[0].setAttribute('value', sitelauncherUtilsMisc.getLocaleString("setLauncherAsHomepage"));            
          }
        }, false);                 
        listitem.appendChild(label);
        vbox.appendChild(listitem);
        sitelauncherLauncher.menu.listItems[x++] = listitem;
        
        listitem = document.createElement('hbox');
        listitem.setAttribute('value', 3);
        listitem.setAttribute('align', 'center');   
        listitem.style.setProperty('padding', '0.2em', null);        
        listitem.style.setProperty('margin', '0 1px 1px 1px', null);             
        listitem.addEventListener('mouseover', sitelauncherLauncher.menu.mouseOver, false);  
        listitem.addEventListener('click', function(e){
          sitelauncherLauncher.hide();
          sitelauncherUtilsMisc.showPrefOptionsView();}, false);
        label = sitelauncherUtilsDom.createLabel(sitelauncherUtilsMisc.getLocaleString("moreOptions"));          
        listitem.appendChild(label);
        vbox.appendChild(listitem);
        sitelauncherLauncher.menu.listItems[x++] = listitem;
    
        var w = sitelauncherLauncher.width - 60;
        
        if(sitelauncherLauncher.scrollbarVisible)
        {
          w -= 23;
        }
    
        sitelauncherPanels.add('sitelauncherLauncherMenuBox', vbox);
        sitelauncherPanels.setMinWidth('sitelauncherLauncherMenuBox', w);
        sitelauncherPanels.setBgColor('sitelauncherLauncherMenuBox', '#eeeeee');
        sitelauncherPanels.setRoundCorners('sitelauncherLauncherMenuBox', false);
        sitelauncherPanels.bufferAll();
      }
      
      if(!sitelauncherPanels.isShowing('sitelauncherLauncherMenuBox'))
      {
        var items = sitelauncherLauncher.menu.listItems;
        
        for(var x = 0; x < items.length; x++)
        {
          if(items[x].getAttribute('class') === 'selected')
          {
            items[x].setAttribute('class', '');
          }
        }
        
        sitelauncherLauncher.menu.selectedListItem = items[0];
        items[0].setAttribute('class', 'selected');        
      }      
      
      sitelauncherPanels.toggle('sitelauncherLauncherMenuBox');
    },
    
    hide : function(e)
    {
      sitelauncherPanels.hide('sitelauncherLauncherMenuBox');
    },
    
    handleKeyPress : function(e)
    {
      e.preventDefault();
      e.stopPropagation();          

      if(!sitelauncherPanels.isShowing('sitelauncherLauncherMenuBox'))
      {
        return false;
      }
      
      if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_UP || 
         e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_DOWN)
      {
        var items = sitelauncherLauncher.menu.listItems;
        var selItem = sitelauncherLauncher.menu.selectedListItem;
        var prevSelItem = selItem;
        
        if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_UP)
        {
          // select prev item, or jump to end if reached start
          selItem = selItem.previousSibling || items[items.length - 1];
        }
        else
        {
          // select next item, or jump start if reached end
          selItem = selItem.nextSibling || items[0];
        }  
        
        sitelauncherLauncher.menu.selectedListItem = selItem;

        selItem.setAttribute('class', 'selected');
        prevSelItem.setAttribute('class', '');
      }
      else if((e.which === Components.interfaces.nsIDOMKeyEvent.DOM_VK_RETURN ||
               e.which === Components.interfaces.nsIDOMKeyEvent.DOM_VK_SPACE) && 
              sitelauncherLauncher.menu.selectedListItem)
      {
        sitelauncherLauncher.menu.selectedListItem.click();
      }
    },

    release : function(e)
    {
      if(sitelauncherPanels.isShowing('sitelauncherLauncherMenuBox'))
        sitelauncherPanels.cleanUp('sitelauncherLauncherMenuBox');
    },
    
    mouseOver : function(e)
    {
      var prevSelItem = sitelauncherLauncher.menu.selectedListItem;
      var newSel = e.currentTarget;
      
      sitelauncherLauncher.menu.selectedListItem = newSel;
      newSel.setAttribute('class', 'selected');
      
      if(prevSelItem !== newSel)
      {
        prevSelItem.setAttribute('class', '');
      }
    }
  },

  indicateItemPressed : function(id)
  {
    var iconStyle = sitelauncherLauncher.getItemIconById(id).style;  
    if(iconStyle)
    { 
      iconStyle.setProperty('opacity', .7, null);
      setTimeout(function(e){
        iconStyle.setProperty('opacity', '', null);
          setTimeout(function(e){
            sitelauncherLauncher.hide();}, 0);}, 60);
    }
    else
    {
      sitelauncherLauncher.hide();
    }
  },
  
  updateBackground : function()
  {
    if(sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.opacity') === 10 && 
       !sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.roundedCorners') &&
       !sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.border') && 
       sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.gradient') === 0)
    {
      sitelauncherLauncher.nodes.base.style.setProperty('background',
        sitelauncherLauncher.prefAccessor.getCharPref('extensions.sitelauncher.launcher.color.background'), '');

      sitelauncherLauncher.nodes.bufferFrame.contentDocument.getElementById('sitelauncherBox').style.setProperty('background',
        sitelauncherLauncher.prefAccessor.getCharPref('extensions.sitelauncher.launcher.color.background'), '');      
      return;
    }

    var sitelauncherObj = sitelauncherLauncher.nodes.bufferFrame.contentDocument.getElementById('sitelauncherBox').boxObject;
    var width = sitelauncherObj.width;
    var height = sitelauncherLauncher.height;
    var bgcolor = sitelauncherLauncher.prefAccessor.getCharPref('extensions.sitelauncher.launcher.color.background');
    var opacity = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.opacity') / 10;
    var gradient = sitelauncherLauncher.prefAccessor.getIntPref('extensions.sitelauncher.launcher.gradient');
    var roundedCorners = sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.roundedCorners');
    var border = sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.launcher.border');
  
    var bg = sitelauncherUtilsMisc.createBackgroundImage(
      width, height, bgcolor, opacity, gradient, roundedCorners ? 30 : false, border);
      
    sitelauncherLauncher.nodes.bufferFrame.contentDocument.getElementById('sitelauncherBox').style.
      setProperty('background', 'url("' + bg + '") 0px 0px no-repeat', '');
    sitelauncherLauncher.nodes.base.style.
      setProperty('background', 'url("' + bg + '") 0px 0px no-repeat', '');
  
    return;
  },

  isKeyEventAltGrCandidate : function(e)
  {
    // return early if we can (for sake of efficiency)
    if(!e.altKey || !e.ctrlKey || sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.altGr'))
    {
      return false;
    }

    var altKey = sitelauncherLauncher.keyConstants.DOM_VK_ALT;
    var ctrlKey = sitelauncherLauncher.keyConstants.DOM_VK_CONTROL;
     
    var launcherHotkey = sitelauncherLauncher._launcherHotkeyAsArray;
    var shortcutHotkey = sitelauncherLauncher._DTSHotkeyAsArray; 
           
    if( (launcherHotkey.indexOf(altKey) > -1 && launcherHotkey.indexOf(ctrlKey) > -1) || 
        (shortcutHotkey.indexOf(altKey) > -1 && shortcutHotkey.indexOf(ctrlKey) > -1 &&
         sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.shortcut.enabled')) )
    {
      return false;
    }    
    
    return true;
  },
  
  isLauncherHotkeyMatch : function(activeKeys)
  {
    var launcherHotkey = sitelauncherLauncher._launcherHotkeyAsArray;
	
    return !(launcherHotkey[0] === -1 && launcherHotkey[1] === -1) &&
	       (activeKeys.indexOf(launcherHotkey[0]) > -1 && 
            (activeKeys.indexOf(launcherHotkey[1]) > -1 || launcherHotkey[1] === -1));      
  },
  
  isDTSHotkeyMatch : function(activeKeys)
  {
    var shortcutHotkey = sitelauncherLauncher._DTSHotkeyAsArray;  
	
    return (!(shortcutHotkey[0] === -1 && shortcutHotkey[1] === -1) && 
  	        sitelauncherLauncher.prefAccessor.getBoolPref('extensions.sitelauncher.shortcut.enabled') && 
            activeKeys.indexOf(shortcutHotkey[0]) > -1 && 
            (activeKeys.indexOf(shortcutHotkey[1]) > -1 || shortcutHotkey[1] === -1));    
  },
  
  _isScrollbarRequired : function()
  {
    return sitelauncherLauncher.scrollbarVisible;
  },
  
  _getLauncherHotkeyAsArray : function()
  {
    return [sitelauncherLauncher.modifiers[sitelauncherLauncher.prefAccessor.
              getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.primary')],
            sitelauncherLauncher.modifiers[sitelauncherLauncher.prefAccessor.
              getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.secondary')]];
  },
  
  _getDTSHotkeyAsArray : function()
  {
    return [sitelauncherLauncher.modifiers[sitelauncherLauncher.prefAccessor.
              getIntPref('extensions.sitelauncher.shortcut.modifiers.primary')],
            sitelauncherLauncher.modifiers[sitelauncherLauncher.prefAccessor.
              getIntPref('extensions.sitelauncher.shortcut.modifiers.secondary')]];  
  },
  
  listeners : 
  {
    keydown : function(e)
    { 
      if(sitelauncherLauncher.mode !== sitelauncherLauncher.IDLEMODE)
      {
        e.preventDefault();
        e.stopPropagation();
      }

      // return as soon as we know we can for maxiumum performance
      if(sitelauncherLauncher.mode === sitelauncherLauncher.modes.shortcut || 
         sitelauncherLauncher.isKeyEventAltGrCandidate(e))
      {
        return;
      }
      
      var activeKeys = [-1];
      var i = 0;

      if(e.keyCode > -1) 
      {
        activeKeys[i++] = e.keyCode; 
      }
      if(e.shiftKey) 
      {
        activeKeys[i++] = sitelauncherLauncher.SHIFT_KEY;
      }
      if(e.ctrlKey)
      {
        activeKeys[i++] = sitelauncherLauncher.CTRL_KEY;
      }
      if(e.altKey)
      {
        activeKeys[i++] = sitelauncherLauncher.ALT_KEY;
      }
      if(e.metaKey)
      {
        activeKeys[i++] = sitelauncherLauncher.META_KEY;
      }
	  
      if(sitelauncherLauncher.isLauncherHotkeyMatch(activeKeys))
      {
        launcherHotkeyModifier = sitelauncherLauncher._launcherHotkeyAsArray[1];		
	  
        if(sitelauncherLauncher.mode !== sitelauncherLauncher.modes.launcher)
        {
          sitelauncherLauncher.mode = sitelauncherLauncher.modes.launcher;  
          sitelauncherLauncher.launcherHotKeyDown = true;
          e.preventDefault();
          e.stopPropagation();
          sitelauncherLauncher.show();          
        }
        else if(!sitelauncherLauncher.launcherHotKeyDown) // are we canceling launcher?
        {
          e.stopPropagation(); 
          e.preventDefault();     
          sitelauncherLauncher.hide();
        }
      }
      else if(sitelauncherLauncher.isDTSHotkeyMatch(activeKeys))
      {
        sitelauncherLauncher.mode = sitelauncherLauncher.modes.shortcut;
        e.preventDefault();
        e.stopPropagation();
        sitelauncherLauncher.show();
      }
    },
   
    keyup : function(e)
    {
      if(sitelauncherLauncher.mode === sitelauncherLauncher.modes.shortcut)
      {
        e.preventDefault(); 
        e.stopPropagation();        
        sitelauncherLauncher.mode = sitelauncherLauncher.modes.idle; 
      }
      else if(sitelauncherLauncher.mode === sitelauncherLauncher.modes.launcher)
      {
        e.preventDefault(); 
        e.stopPropagation();        
        if(e.keyCode === sitelauncherLauncher.modifiers[sitelauncherLauncher.prefAccessor.
           getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.primary')])
        {
          sitelauncherLauncher.launcherHotKeyDown = false;
        }
      }
    },
  } 
};