// Copyright (c) 2008-2011 Done Smart Ltd (donesmart.com)
//
// This software is property of Done Smart Ltd,
// do not redistribute any part of it without our
// permission.
var sitelauncherPlugins = 
{
  hooks : {launcherShown          : 'launcherShown',        // X panel shown
           launcherHidden         : 'launcherHidden',       // X panel hidden
           launcherBuffered       : 'launcherBuffered',     // X panel drawn in iframe 
           launcherLinkAdded      : 'launcherLinkAdded',    // X link inserted into panel
           launcherLinkKey        : 'launcherLinkKey',      // X link pressed by key
//         launcherLinkClick      : 'launcherLinkClick',    // link pressed by mouse click
           launcherLinkOpened     : 'launcherLinkOpened',   // X link opened
           launcherLinksUpdated   : 'launcherLinksUpdated', // X links drawn (before buffer)
           directLinkKey          : 'directLinkKey'},       // X
  objects : {},
  enabled : [],
  
  init : function()
  {
    sitelauncherPlugins.enabled =
      sitelauncher.prefs.getCharPref('extensions.sitelauncher.plugins.enabled').split('|');
    
    if(!sitelauncherPlugins.enabled.length)
      return;
 
    sitelauncherLauncher.nodes.canvasFrame.contentWindow.sitelauncherPlugins = sitelauncherPlugins;
    sitelauncherLauncher.nodes.canvasFrame.contentWindow.sitelauncherLauncher = sitelauncherLauncher;
    sitelauncherLauncher.nodes.canvasFrame.contentWindow.sitelauncher = sitelauncher;
  },
  
  register : function(id, obj)
  {
    sitelauncherPlugins.objects[id] = obj;
    if(sitelauncherPlugins.enabled.indexOf(id) !== -1)
      sitelauncherPlugins.objects[id].init();
  },
  
  enable : function(id)
  {
    if(sitelauncherPlugins.enabled.indexOf(id) === -1)
    {
      sitelauncherPlugins.enabled.push(id);
      sitelauncher.prefs.setCharPref('extensions.sitelauncher.plugins.enabled',
        sitelauncherPlugins.enabled.join('|'));
        
      if(id in sitelauncherPlugins.objects)
        sitelauncherPlugins.objects[id].init();
    }
  },
  
  disable : function(id)
  {
    var i = sitelauncherPlugins.enabled.indexOf(id);
    if(i !== -1)
    {
      sitelauncherPlugins.enabled.splice(i, 1);
      sitelauncher.prefs.setCharPref('extensions.sitelauncher.plugins.enabled',
        sitelauncherPlugins.enabled.join('|'));
      sitelauncherPlugins.objects[id].dinit();
    } 
  },
  
  fire : function(hook, after, context)
  {
    if(!sitelauncherPlugins.enabled.length)
      return;
      
    var finish = false;
    var stage = after ? 'after' : 'before';
    
    for(var x in sitelauncherPlugins.objects)
    {
      if(sitelauncherPlugins.enabled.indexOf(x) !== -1 && 
         typeof sitelauncherPlugins.objects[x][hook] !== 'undefined' &&
         typeof sitelauncherPlugins.objects[x][hook][stage] === 'function')
      {
        if(sitelauncherPlugins.objects[x][hook][stage](context))
        {
          finish = true;
        }
      }
    }

    return finish;        
  }
}
