// Copyright (c) 2008-2011 Done Smart Ltd (donesmart.com)
//
// This software is property of Done Smart Ltd,
// do not redistribute any part of it without our
// permission.
function SitelauncherPrefMon()
{
  this.listeners = [];
  this.changedPrefValues = {};
    
  this.attachToAllControls = function()
  {
    this.attachToAllControlsOfType('checkbox', 'command');
    this.attachToAllControlsOfType('menulist', 'command');
    this.attachToAllControlsOfType('radio', 'command'); 
    this.attachToAllControlsOfType('textbox', 'change');
    this.attachToAllControlsOfType('colorpicker', 'change');        
  };
  
  this.attachToAllControlsOfType = function(controlType, eventType)
  {
    var items = document.getElementsByTagName(controlType);
    for(var x = 0; x < items.length; x++)
    {
      items[x].addEventListener(eventType, this['catch_' + controlType + 'Change'], false);
    }
  };
  
  this.catch_checkboxChange = function(e)
  {
    var prefName = sitelauncherPrefMon.getPrefNameOfControl(e.currentTarget);
   
    if(prefName !== null)
    {
      var prefValue = e.currentTarget.hasAttribute('checked');
      sitelauncherPrefMon.changedPrefValues[prefName] = prefValue;
      sitelauncherPrefMon.firePrefChangeSignal(prefName, prefValue);
    }
  };
  
  this.catch_menulistChange = function(e)
  {
    var prefName = sitelauncherPrefMon.getPrefNameOfControl(e.currentTarget);
    if(prefName !== null)
    {        
      var prefValue = e.currentTarget.getAttribute('value');
      sitelauncherPrefMon.changedPrefValues[prefName] = prefValue;      
      sitelauncherPrefMon.firePrefChangeSignal(prefName, prefValue);
    }
  };
  
  this.catch_radioChange = function(e)
  {
    var node = e.currentTarget;
    var radiogroup = null;
    var ancestorLimit = 5;
    for(var x = 0; node && x < ancestorLimit; node = node.parentNode, x++) 
    {
      if(node.tagName === "radiogroup")
      {
        radiogroup = node;
        break;
      }      
    }
    
    if(radiogroup) 
    {
      var prefName = sitelauncherPrefMon.getPrefNameOfControl(radiogroup);
      if (prefName !== null)
      {
        var prefValue = e.currentTarget.getAttribute('value');
        sitelauncherPrefMon.changedPrefValues[prefName] = prefValue;        
        sitelauncherPrefMon.firePrefChangeSignal(prefName, prefValue);
      }
    }      
  };  
  
  this.catch_textboxChange = function(e)
  {
    var prefName = sitelauncherPrefMon.getPrefNameOfControl(e.currentTarget);
    if (prefName !== null)
    {
      var prefValue = e.currentTarget.value;
      sitelauncherPrefMon.changedPrefValues[prefName] = prefValue;      
      sitelauncherPrefMon.firePrefChangeSignal(prefName, prefValue);        
    } 
  };    
  
  this.catch_colorpickerChange = function(e)
  {
    var prefName = sitelauncherPrefMon.getPrefNameOfControl(e.currentTarget);
    if (prefName !== null)
    {
      var prefValue = e.currentTarget.getAttribute("color");
      sitelauncherPrefMon.changedPrefValues[prefName] = prefValue;      
      sitelauncherPrefMon.firePrefChangeSignal(prefName, prefValue);
    }
  };
  
  this.getPrefNameOfControl = function(elm)
  {
    var prefId = elm.getAttribute("preference");
    if(prefId !== null && prefId !== "")
    {
      return document.getElementById(prefId).getAttribute("name");
    }
    
    return null;
  };
 
  this.firePrefChangeSignal = function(name, newValue)
  {
    for(var x = 0; x < this.listeners.length; x++)
    {
      this.listeners[x](name, newValue);
    }
  };

  this.attachPrefChangeListener = function(func)
  {
    this.listeners.push(func);
  };
  
  this.getIntPref = function(name)
  {
    if(typeof sitelauncherPrefMon.changedPrefValues[name] !== "undefined") 
    {
      return parseInt(sitelauncherPrefMon.changedPrefValues[name], 10);
    }
    else 
    {
      return sitelauncher.getIntPref(name);
    }
  };
  
  this.getBoolPref = function(name)
  {
    if(typeof sitelauncherPrefMon.changedPrefValues[name] !== "undefined") 
    {
      return !!sitelauncherPrefMon.changedPrefValues[name];
    }
    else 
    {
      return sitelauncher.getBoolPref(name);
    }
  };
  
  this.getCharPref = function(name)
  {
    if(typeof sitelauncherPrefMon.changedPrefValues[name] !== "undefined") 
    {
      return "" + sitelauncherPrefMon.changedPrefValues[name];
    }
    else 
    {
      return sitelauncher.getCharPref(name);
    }
  };
}
var sitelauncherPrefMon = new SitelauncherPrefMon();
