var sitelauncherPrefs = 
{
  changesMade : false,
  nodes : {},
  showGroups : false,  
  showCustomIconsFeature : false,  
  messageBeingShown : false, 
  sortDeniedIconShowing : false,  
  optionsPaneState : 0,  
  targetGroup : null,    
  editViewTypes : {'shortcutAdd': 0,
                   'shortcutRevise' : 1,
                   'group' : 2,
                   'groupTitle' : 3,
                   'customIconURL' : 4,
                   'blank' : 5},
  lastEditView : -1,
  currentEditView : 5,
  selectedShortcutId : null,
  selectedItemType : null,
  itemTypes : {'shortcut' : 0,
               'group' : 1},
  textPromptShowing: null,
  textPromptCallbackMethod : null,  
  previewShowing : false,
  signalingConflict : false,
  lastConflictShortcut : null,
  isMacPlatform : false,
  customIconButtonShowing : false,
  addBackButtonShowing : false,
  addFormLeftIncomplete : false,
  incompleteAddFormValues : {'title' : '',
                             'url' : '',
                             'key' : ''},     
  
  load : function()
  {
    // speed things up by storing nodes we'll be using often
    var nodes = sitelauncherPrefs.nodes;
    nodes.richListBox = document.getElementById('sitelauncherRichlistbox');
    nodes.sortByMenuList = document.getElementById('sitelauncherSortByMenulist');
    nodes.managePane = document.getElementById('sitelauncherPrefPaneManage');

    nodes.groupEditBox = document.getElementById('sitelauncherGroupEditBox');
    nodes.labelGroupTitle = document.getElementById('sitelauncherGroupTitleLabel');
    
    nodes.editBox = document.getElementById('sitelauncherEditBox');
    nodes.textBoxTitle = document.getElementById('sitelauncherTextboxTitle');
    nodes.textBoxUrl = document.getElementById('sitelauncherTextboxUrl');
    nodes.textBoxKey = document.getElementById('sitelauncherTextboxKey');
    nodes.customIconButton = document.getElementById('sitelauncherCustomIconButton');      
    nodes.siteSaveButton = document.getElementById('sitelauncherSaveButton');    
    
    sitelauncherPrefs.compactViewIfNeeded();
    
    sitelauncherPrefs.OS = 
    Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
    sitelauncher.load();

    sitelauncherPrefs.showGroups = sitelauncher.getBoolPref('extensions.sitelauncher.grouping');
    sitelauncherPrefs.showCustomIconsFeature = sitelauncher.getBoolPref('extensions.sitelauncher.enableCustomIcons');

    sitelauncherPrefs.draw();
    
    if(sitelauncherPrefs.OS === 'Darwin' /* && document.documentElement.instantApply */ )
    {
      sitelauncherPrefs.isMacPlatform = true;
      document.documentElement.setAttribute('__sitelauncher_OS', 'OSX');
    }
    
    if(document.documentElement.instantApply)
    {
      window.addEventListener('unload', sitelauncherPrefs.saveShortcutDataIfChanged, true);
    }
    else
    {
      window.addEventListener('dialogaccept', sitelauncherPrefs.saveShortcutDataIfChanged, true);
    }
    
    sitelauncherPrefs.nodes.richListBox.addEventListener('mousedown',
      sitelauncherPrefs.listboxMouseDown, true);
    
    sitelauncherPrefs.nodes.textBoxKey.addEventListener('keydown',
      sitelauncherPrefs.addShortcutIfReturnPressed, true);
    sitelauncherPrefs.nodes.textBoxKey.addEventListener('keyup', 
      sitelauncherPrefs.checkConflict, true);
    sitelauncherPrefs.nodes.textBoxTitle.addEventListener('keydown',
      sitelauncherPrefs.addShortcutIfReturnPressed, true);
    sitelauncherPrefs.nodes.textBoxUrl.addEventListener('keydown',
      sitelauncherPrefs.addShortcutIfReturnPressed, true);
      
    sitelauncherPrefs.nodes.managePane.addEventListener('keydown', 
      function(e)
      {
        if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_ESCAPE &&
           (sitelauncherPrefs.textPromptShowing ||
            sitelauncherPrefs.currentEditView !== sitelauncherPrefs.editViewTypes.blank))
        {
          e.preventDefault();
          e.stopPropagation();
          sitelauncherPrefs.showDefaultEditView(); 
          sitelauncherPrefs.nodes.richListBox.focus();
        }
      }, false);
    
    document.getElementById("sitelauncherTextPromptTextbox").addEventListener('keydown', 
      sitelauncherPrefs.handleTextPromptKeydown, true);
      
    sitelauncherPrefs.nodes.richListBox.addEventListener('keydown', 
      sitelauncherPrefs.handleSiteListShortcut, false);
      
    sitelauncherHooks.attach('newSiteIconLoaded', 
      function(e)
      {
        sitelauncherPrefs.drawAndKeepSelected();
        sitelauncherPrefs.assertChangesPending();        
      });
      
    if(sitelauncherPrefs.showGroups)
    {
      sitelauncherPrefs.showGroupingUI();
    }

    if(sitelauncherPrefs.showCustomIconsFeature)
    {
      sitelauncherPrefs.showCustomIconsUI();
    }

    if(window.arguments)
    {
      if(window.arguments[1])
      {
        var content_url = window.arguments[1];
        var content_title = typeof window.arguments[2] === "string" ? window.arguments[2] : "";
  
        sitelauncherPrefs.populateAddFormWithURL(content_url, content_title);
      }
      else if(window.arguments[0] && window.arguments[0] === 'sitelauncherPrefPaneManage')
      {
        nodes.richListBox.focus();
      }
    }

    sitelauncherPrefMon.attachToAllControls();
    sitelauncherPrefMon.attachPrefChangeListener(sitelauncherPrefs.prefChangeListener);
    
    sitelauncherPrefs.populateNonStaticHotkeyLabels();
  },  
  
  assertChangesPending : function()
  {
    sitelauncherPrefs.changesMade = true;
  },
  
  confirm : function()
  {
    if(document.documentElement.instantApply || !sitelauncherPrefs.changesMade)
    {
      return true;
    }
    
    var prompts = Components.classes['@mozilla.org/embedcomp/prompt-service;1'].getService(Components.interfaces.nsIPromptService);
    return prompts.confirm(null, '', sitelauncherUtilsMisc.getLocaleString("confirmCancel"));
  },
  
  select : function(id)
  {
    var selectedItem = sitelauncherPrefs.nodes.richListBox.selectedItem;
    
    sitelauncherPrefs.selectedShortcutId = null; // we'll assign once sure valid
    sitelauncherPrefs.selectedItemType = null;
    
    if(sitelauncherPrefs.showGroups &&
       selectedItem.hasAttribute('__sitelauncherGroup'))
    {
      sitelauncherPrefs.selectedItemType = sitelauncherPrefs.itemTypes.group;

      var groupId = parseInt(selectedItem.getAttribute('__sitelauncherGroup'), 10);
      var group = sitelauncher.getGroupById(groupId);

      sitelauncherPrefs.setTargetGroupById(groupId);
      
      if(group.showEditTitleViewFirst) 
      {
        sitelauncherPrefs.showEditGroupTitleView();
        group.showEditTitleViewFirst = false;
      }
      else 
      {
        if(sitelauncherPrefs.currentEditView !== sitelauncherPrefs.editViewTypes.shortcutAdd && 
           sitelauncherPrefs.currentEditView !== sitelauncherPrefs.editViewTypes.blank)
        {
          sitelauncherPrefs.showDefaultEditView();           
        }
      }
      
      sitelauncherPrefs.showCustomIconButtonIfApplicable();      

      return;
    }
    
    var site = sitelauncher.getSiteById(id);
    
    if(site)
    {
      sitelauncherPrefs.selectedItemType = sitelauncherPrefs.itemTypes.shortcut;
      sitelauncherPrefs.selectedShortcutId = site.id;
      
      var item = sitelauncherPrefs.getSiteRichListItemById(site.id);

      if(item && selectedItem != item)
      {
        sitelauncherPrefs.nodes.richListBox.selectItem(item);
      }

      sitelauncherPrefs.setTargetGroupById(site.groupId);
      
      if(sitelauncherPrefs.currentEditView !== sitelauncherPrefs.editViewTypes.shortcutAdd && 
         sitelauncherPrefs.currentEditView !== sitelauncherPrefs.editViewTypes.blank)
      {
        sitelauncherPrefs.showDefaultEditView();           
      }      
      
      sitelauncherPrefs.showCustomIconButtonIfApplicable();
    }
  },
  
  listboxMouseDown: function(e)
  {
    // don't let selected item change if drag occuring
    if(sitelauncherPrefs.dragGestured && e.button !== 0)
    {
      e.stopPropagation();
      e.preventDefault();
    }
  },

  checkConflict : function(e)
  {
    sitelauncherPrefs.lastConflictShortcut = null;

    var letter = sitelauncherPrefs.nodes.textBoxKey.value;
    
    if(letter === '')
    {
      return;
    }
    
    if(e && e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_SPACE)
    {  
      e.stopPropagation(); 
      e.preventDefault();
      return;
    }
    
    var conflict_shortcut = sitelauncher.getSiteByKey(letter);
    
    if(conflict_shortcut && /* ignore "conflict" with self */ 
       !(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.shortcutRevise &&
         conflict_shortcut.id === sitelauncherPrefs.selectedShortcutId))
    {
      sitelauncherPrefs.lastConflictShortcut = conflict_shortcut;

      if(e)
      {
        e.preventDefault();
        e.stopPropagation();
      }
      
      var url = sitelauncherPrefs.nodes.textBoxUrl.value;
                          
      //sitelauncherPrefs.nodes.textBoxKey.value = '';
      sitelauncherPrefs.nodes.textBoxKey.select();
      
      var item = sitelauncherPrefs.getSiteRichListItemByKey(letter);
      if(item && !sitelauncherPrefs.signalingConflict)
      {
        // signal conflict to user
        sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(item);
      
        var count = 0;
        var intervalId = null;
        
        function highlightConflictStep(e)
        {
          if(count > 3)
          {
            sitelauncherPrefs.signalingConflict = false;
            item.style.setProperty('background', '', null);
            if(intervalId !== null)
            {
              clearInterval(intervalId);
              intervalId = null;
            }
            return;
          }
          
          var color = item.style.getPropertyValue('background-color') != '' ? '' : '#de4747';
          item.style.setProperty('background', color, null); 
          count++;
        };
        
        sitelauncherPrefs.signalingConflict = true;
        intervalId = setInterval /* referencing function */ (highlightConflictStep, 80);
      }
      
      return true;
    }
    
    return false;
  },
  
  deleteConflictKeyInstance : function()
  {
    sitelauncherPrefs.hideConflictButton();

    if(sitelauncherPrefs.lastConflictShortcut === null)
    {
      return;
    }

    var site = sitelauncherPrefs.lastConflictShortcut;
    site = sitelauncher.revise(site.id, "", site.title,  site.url);

    if(site === false)
    {
      return;
    }    
    
    sitelauncher.sort(parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10));
    sitelauncherPrefs.drawAndKeepSelected();
    sitelauncherPrefs.assertChangesPending();
  },
  
  getSiteRichListItemByKey : function(key)
  {
    return sitelauncherPrefs.getSiteRichListItemById(sitelauncher.getSiteByKey(key).id);
  },
  
  getSiteRichListItemById : function(id)
  {
    return sitelauncherUtilsDom.getFirstElmByAttr(sitelauncherPrefs.nodes.richListBox, '__slItemId', id);
  },
    
  getSiteByElement : function(elm)
  {
    return sitelauncher.getSiteById(elm.getAttribute('__slItemId'));
  },
  
  getGroupByElement : function(elm)
  {
    return sitelauncher.getGroupById(parseInt(elm.getAttribute('__sitelauncherGroup'), 10));
  },

  getGroupListItemById : function(id)
  {
    return sitelauncherPrefs.nodes.richListBox.getElementsByAttribute('__sitelauncherGroup', id)[0];
  },

  selectGroupListItem : function(id)
  {
    var item = sitelauncherPrefs.getGroupListItemById(id);
    
    if(item)
    {
      item.setAttribute('__sitelauncherUserSelected', 'false');
      sitelauncherPrefs.nodes.richListBox.selectedItem = item;
      item.focus();
 
      return item;
    }    
    
    return null;
  },
  
  selectSiteListItem : function(id)
  {
    var item = sitelauncherPrefs.getSiteRichListItemById(id);
    
    if(item)
    {
      sitelauncherPrefs.nodes.richListBox.selectedItem = item;
      item.focus();
      
      return item;
    }
    
    return null;
  },
    
  setTargetGroupById : function(id)
  {
    var group = sitelauncher.getGroupById(id);
    sitelauncherPrefs.targetGroup = group;
    sitelauncherPrefs.nodes.labelGroupTitle.value = group.title;
  },
  
  showEditGroupTitleView : function()
  {
    sitelauncherPrefs.closeTextPrompt();
    sitelauncherPrefs.showCustomIconButtonIfApplicable();      

    if(sitelauncherPrefs.targetGroup === null)
    {
      return;  
    }        
    
    sitelauncherPrefs._setCurrentEditView(sitelauncherPrefs.editViewTypes.groupTitle);    
    
    var width = sitelauncherPrefs.nodes.richListBox.boxObject.width;
    sitelauncherPrefs.nodes.richListBox.style.setProperty('min-width', width + 'px', null);
    
    sitelauncherPrefs.showTextPrompt(sitelauncherPrefs.renameGroup, 
                                     sitelauncherPrefs.targetGroup.title, 
                                     sitelauncherUtilsMisc.getLocaleString("changeTitle"),
                                     sitelauncherUtilsMisc.getLocaleString("title"));
  },
  
  showDefaultEditView : function()
  {
    sitelauncherPrefs.showBlankEditView();

    if(sitelauncherPrefs.addFormLeftIncomplete)
    {
      sitelauncherPrefs.showAddBackButton();
    }
  },
  
  showBlankEditView : function()
  {
    sitelauncherPrefs.closeTextPrompt();
    sitelauncherPrefs.showCustomIconButtonIfApplicable();  
    sitelauncherPrefs.hideAddBackButton();  

    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.blank)
    {
      return;  
    }        
    
    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.blank)
    {
      sitelauncherPrefs.showAddShortcutButton();
      sitelauncherPrefs.nodes.textBoxTitle.value = "";
      sitelauncherPrefs.nodes.textBoxUrl.value = "";
      sitelauncherPrefs.nodes.textBoxKey.value = "";      
    }
    
    sitelauncherPrefs.nodes.editBox.style.setProperty("visibility", "hidden", null);    

    sitelauncherPrefs._setCurrentEditView(sitelauncherPrefs.editViewTypes.blank);
  },
  
  showEditShortcutView : function()
  {
    if(sitelauncherPrefs.selectedShortcutId === null) 
    {
      return;
    }

    sitelauncherPrefs.closeTextPrompt();
    sitelauncherPrefs.showCustomIconButtonIfApplicable();      
    sitelauncherPrefs.hideAddBackButton();      
    
    var site = sitelauncher.getSiteById(sitelauncherPrefs.selectedShortcutId);
    
    // remember if incomplete shortcut addition
    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.shortcutAdd)
    {
      sitelauncherPrefs.addFormLeftIncomplete = true;
      sitelauncherPrefs.incompleteAddFormValues.title = sitelauncherPrefs.nodes.textBoxTitle.value;
      sitelauncherPrefs.incompleteAddFormValues.url =  sitelauncherPrefs.nodes.textBoxUrl.value;
      sitelauncherPrefs.incompleteAddFormValues.key = sitelauncherPrefs.nodes.textBoxKey.value;
    }
    else
    {
      sitelauncherPrefs.addFormLeftIncomplete = false;
    }    

    sitelauncherPrefs.nodes.textBoxKey.value = site.key;
    sitelauncherPrefs.nodes.textBoxTitle.value = site.title;
    sitelauncherPrefs.nodes.textBoxUrl.value = site.url;

    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.shortcutRevise)
    {
      sitelauncherPrefs.nodes.textBoxTitle.select();
      return;  
    }    
    
    sitelauncherPrefs._setCurrentEditView(sitelauncherPrefs.editViewTypes.shortcutRevise); 

    sitelauncherPrefs.nodes.editBox.style.setProperty("visibility", "visible", null);
    sitelauncherPrefs.showReviseShortcutButton();
    
    sitelauncherPrefs.nodes.textBoxTitle.select();
  },
  
  showAddShortcutView : function()
  {
    sitelauncherPrefs.closeTextPrompt(); 
    sitelauncherPrefs.showCustomIconButtonIfApplicable();   
    sitelauncherPrefs.hideAddBackButton();    

    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.shortcutAdd)
    {
      return;  
    }        
    
    sitelauncherPrefs._setCurrentEditView(sitelauncherPrefs.editViewTypes.shortcutAdd);      
    
    sitelauncherPrefs.nodes.editBox.style.setProperty("visibility", "visible", null);   
    sitelauncherPrefs.showAddShortcutButton();

  },
  
  showAddBackButton : function()
  {
    if(!sitelauncherPrefs.addBackButtonShowing)
    {
      document.getElementById("sitelauncherConflictRetryBox").style.setProperty("display", "-moz-box", null);
      sitelauncherPrefs.addBackButtonShowing = true;
    }   
  },
  
  hideAddBackButton : function()
  {
    if(sitelauncherPrefs.addBackButtonShowing)
    {
      document.getElementById("sitelauncherConflictRetryBox").style.setProperty("display", "none", null);  
      sitelauncherPrefs.addBackButtonShowing = false;
    }        
  },
  
  returnToAddingShortcut : function()
  {
    sitelauncherPrefs.showAddShortcutView();
    sitelauncherPrefs.nodes.textBoxTitle.value = sitelauncherPrefs.incompleteAddFormValues.title;
    sitelauncherPrefs.nodes.textBoxUrl.value = sitelauncherPrefs.incompleteAddFormValues.url;
    sitelauncherPrefs.nodes.textBoxKey.value = sitelauncherPrefs.incompleteAddFormValues.key;
    sitelauncherPrefs.nodes.textBoxTitle.select();    
    sitelauncherPrefs.hideAddBackButton();
    sitelauncherPrefs.addFormLeftIncomplete = false;
  },
  
  showAddShortcutButton : function()
  {
    var button = sitelauncherPrefs.nodes.siteSaveButton;    
    button.setAttribute('label', sitelauncherUtilsMisc.getLocaleString("addShortcut"));
  },
  
  showReviseShortcutButton : function()
  {
    var button = sitelauncherPrefs.nodes.siteSaveButton;    
    var width = button.boxObject.width;
    button.style.setProperty('width', width + 'px', null);
    button.setAttribute('label', sitelauncherUtilsMisc.getLocaleString("reviseShortcut")); 
  },
  
  add : function()
  {
    if(sitelauncherPrefs.checkConflict() === true)
    {
      return;
    }
    
    var site;
    var key = sitelauncherPrefs.nodes.textBoxKey.value;
    
    if(sitelauncherPrefs.currentEditView === sitelauncherPrefs.editViewTypes.shortcutRevise)
    {
      if(sitelauncherPrefs.selectedShortcutId === null)
      {
        return;
      }      

      var site = sitelauncher.revise(sitelauncherPrefs.selectedShortcutId,
                                     key,
                                     sitelauncherPrefs.nodes.textBoxTitle.value, 
                                     sitelauncherPrefs.nodes.textBoxUrl.value);
    }
    else // add shortcut
    {
      var url = sitelauncherPrefs.nodes.textBoxUrl.value;
      var title = sitelauncherPrefs.nodes.textBoxTitle.value

      if(url.replace(/\s+/, "") === "")
      {
        return;
      }

      var site = sitelauncher.add(key, title, url);
                   
      // move to current selected group
      if(site && sitelauncherPrefs.showGroups)
      {
        var groupId = sitelauncherPrefs.getSelectedGroupId();
        if(groupId > 0)
        {
          sitelauncher.changeGroupById(site.id, groupId);
        }
      }                   
    }
                 
    if(site === false)
    {
      return;
    }

    sitelauncherPrefs.showDefaultEditView(); 
    sitelauncherPrefs.clearWithNoFocus();
            
    sitelauncher.sort(parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10));
    sitelauncherPrefs.draw();

    var item = sitelauncherPrefs.getSiteRichListItemById(site.id);
    if(item)
    {
      sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(item);
      sitelauncherPrefs.nodes.richListBox.selectedItem = item;
      sitelauncherPrefs.nodes.richListBox.focus();
    }

    sitelauncherPrefs.assertChangesPending();
  },
  
  populateShortcutForm : function(title, url)
  {
    sitelauncherPrefs.showAddNewShortcutForm();
    
    sitelauncherPrefs.nodes.textBoxKey.value = '';
    sitelauncherPrefs.nodes.textBoxTitle.value = title;
    sitelauncherPrefs.nodes.textBoxUrl.value = url;
        
    sitelauncherPrefs.nodes.textBoxKey.focus();
  },
  
  attachCustomIconFileToShortcut : function(id, file)
  {
    var site = sitelauncher.getSiteById(id);
  },
  
  removeGroup : function(id)
  {
    if(id === 0)
    {
      var prompts = Components.classes['@mozilla.org/embedcomp/prompt-service;1'].getService(Components.interfaces.nsIPromptService);
      var result = prompts.confirm(null, '', sitelauncherUtilsMisc.getLocaleString("cannotDeleteMainGroup"));
      
      if(result)
      {
        sitelauncher.deleteGroupContents(id);
        sitelauncherPrefs.draw();    
        sitelauncherPrefs.showDefaultEditView();    
        sitelauncherPrefs.clearWithNoFocus();
        sitelauncherPrefs.assertChangesPending();        
      }
      
      return;
    }
      
    if(sitelauncherPrefs.targetGroup && 
       sitelauncherPrefs.targetGroup.id === id)
    {
      sitelauncherPrefs.targetGroup = null;
    } 
    
    sitelauncher.deleteGroup(id);
    sitelauncherPrefs.draw();    
    sitelauncherPrefs.showDefaultEditView();    
    sitelauncherPrefs.clearWithNoFocus();
    sitelauncherPrefs.assertChangesPending();
  },

  remove : function(id)
  {
    var node = sitelauncherPrefs.getSiteRichListItemById(id);
    if(!node)
    {
      return;
    }
    
    // if we will be leaving a group empty show hint under it
    if(sitelauncherPrefs.showGroups)
    {
      var site = sitelauncher.getSiteById(id);
      if(site.groupId > 0)
      {
        if(sitelauncher.getSitesByGroup(site.groupId).length < 2) // lt 2 because we haven't rm'd yet
        {
          sitelauncherPrefs.nodes.richListBox.
            getElementsByAttribute('__sitelauncherGroup', site.groupId)[0].
              setAttribute('__sitelauncherGroupIsEmpty', 'true');
        }
      }
    }

    var next = node.previousSibling ? node.previousSibling : node.nextSibling;

    // if in group focus next item instead of group header
    if(sitelauncherPrefs.showGroups && next && next.getAttribute('__sitelauncherItemType') === 'group')
    {
      if(node.nextSibling && node.nextSibling.getAttribute('__sitelauncherItemType') === 'shortcut')
      {
        next = node.nextSibling;
      }
      else
      {
        next = null;
      }
    }

    node.parentNode.removeChild(node);
     
    sitelauncher.removeById(id);
    
    if(next)
    {
      sitelauncherPrefs.nodes.richListBox.selectedItem = next;
    }
    else
    {
      sitelauncherPrefs.showDefaultEditView();    
      sitelauncherPrefs.clearWithNoFocus();
    }

    
    sitelauncherPrefs.assertChangesPending();
  },

  changeGroup : function(groupId, suppressSelect)
  {
    var item = sitelauncherPrefs.nodes.richListBox.selectedItem;

    if(item)
    {
      var id = item.getAttribute('__slItemId');
      sitelauncher.changeGroupById(id, groupId);
      sitelauncherPrefs.draw();
      
      if(!suppressSelect)
      {
        sitelauncherPrefs.selectSiteListItem(id);
      }
      
      sitelauncherPrefs.assertChangesPending();
    }
  },  
  
  addGroup : function()
  {
    var id = sitelauncher.addGroup("");
    var group = sitelauncher.getGroupById(id);
    
    group.showEditTitleViewFirst = true;

    sitelauncherPrefs.draw();    
    
    var item = sitelauncherPrefs.getGroupListItemById(id);

    sitelauncherPrefs.nodes.richListBox.selectedItem = item;
    sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(item);
    
    sitelauncherPrefs.assertChangesPending();
  },

  // rename selected group  
  renameGroup : function(newName)
  {
    var group = sitelauncherPrefs.targetGroup;
    if(group)
    {
      group.title = newName;
      sitelauncherPrefs.nodes.labelGroupTitle.value = newName;
      sitelauncherPrefs.showDefaultEditView(); 
      sitelauncherPrefs.drawAndKeepSelected();
      sitelauncherPrefs.nodes.richListBox.focus();   
      sitelauncherPrefs.assertChangesPending();
    }    
  },

  getSelectedGroupId : function()
  {
    if(sitelauncherPrefs.targetGroup)
    {
      return sitelauncherPrefs.targetGroup.id;
    }
    
    return -1;
  },
  
  showAddNewShortcutForm : function()
  {
    sitelauncherPrefs.showAddShortcutView();
    sitelauncherPrefs.clear();
  },

  clear : function()
  {
    sitelauncherPrefs.clearWithNoFocus();
    sitelauncherPrefs.nodes.textBoxTitle.focus();  
  },
  
  populateAddFormWithURL : function(url, title)
  {
    sitelauncherPrefs.showAddShortcutView();

    // prevent conflict with multi site operator
    if(url.indexOf("|") !== -1)
    {
      url = url.replace(/\|/g, '%7C');
    }
      
    sitelauncherPrefs.clearWithNoFocus();
    sitelauncherPrefs.nodes.textBoxUrl.value = url;  
    sitelauncherPrefs.nodes.textBoxTitle.value = title;      
    sitelauncherPrefs.nodes.textBoxTitle.select();  
  },
  
  clearWithNoFocus : function()
  {
    sitelauncherPrefs.nodes.textBoxKey.value = '';
    sitelauncherPrefs.nodes.textBoxTitle.value = '';
    sitelauncherPrefs.nodes.textBoxUrl.value = '';
  },

  addShortcutIfReturnPressed : function(e)
  {
    if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_RETURN)
    {
      // accept dialog if [ctrl / cmd held down] + enter
      if((!sitelauncherPrefs.isMacPlatform && e.ctrlKey) || 
         (sitelauncherPrefs.isMacPlatform && e.cmdKey))
      {
        document.documentElement.acceptDialog();
        return;
      }

      e.preventDefault();
      e.stopPropagation();
      sitelauncherPrefs.add();
    }
  },
  
  addGroupIfReturnPressed : function(e)
  {
    if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_RETURN)
    {
      // accept dialog if [ctrl / cmd held down] + enter
      if((!sitelauncherPrefs.isMacPlatform && e.ctrlKey) || 
         (sitelauncherPrefs.isMacPlatform && e.cmdKey))
      {
        document.documentElement.acceptDialog();
        return;
      }

      e.preventDefault();
      e.stopPropagation();
      sitelauncherPrefs.renameGroup();
    }
  },

  showImportDialog : function(e)
  {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    fileChooser.appendFilters(nsIFilePicker.filterXML);
    fileChooser.init(window, sitelauncherUtilsMisc.getLocaleString("selectImportFile"), nsIFilePicker.modeOpen);
    if(fileChooser.show() === nsIFilePicker.returnOK)
    {
      if(sitelauncher.load(fileChooser.file))
      {
        sitelauncherPrefs.targetGroup = null;
        sitelauncher.sort(parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10));
        sitelauncherPrefs.draw();   
        
        sitelauncherPrefs.resetShortcutListView();
        
        sitelauncherPrefs.assertChangesPending();
      }
      else
      {
        var prompts = Components.classes['@mozilla.org/embedcomp/prompt-service;1'].getService(Components.interfaces.nsIPromptService);
        prompts.alert(null, '', sitelauncherUtilsMisc.getLocaleString("invalidFile"));          
      }     
    }
  },
  
  showExportDialog : function(e)
  {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    fileChooser.appendFilters(nsIFilePicker.filterXML);
    fileChooser.defaultExtension = "xml";
    fileChooser.init(window, sitelauncherUtilsMisc.getLocaleString("enterExportFilename"), nsIFilePicker.modeSave);
    
    var r = fileChooser.show();
    if((r === nsIFilePicker.returnOK || r === nsIFilePicker.returnReplace))
    {
      sitelauncher.exportFile(fileChooser.file);
    }
  },

  showCustomIconURLPrompt : function(e)
  {
    sitelauncherPrefs._setCurrentEditView(sitelauncherPrefs.editViewTypes.customIconURL);
    sitelauncherPrefs.showTextPrompt(sitelauncherPrefs.getIconForSelectedShortcutFromURL, 
                                     "", 
                                     sitelauncherUtilsMisc.getLocaleString("fetchIconFromURL"),
                                     sitelauncherUtilsMisc.getLocaleString("url"));      
  },
  
  getIconForSelectedShortcutFromURL : function(url)
  {
    if(url.replace(/\s+/, "") === "")
    {
      return;
    }

    var siteId = sitelauncherPrefs.selectedShortcutId;
    var site = sitelauncher.getSiteById(siteId);
    if(siteId === null || site === null)
    {
      return;
    }          
      
    sitelauncherSiteIcons.backupOriginalIconData(site);
    sitelauncherSiteIcons.insertSiteIconsFromCustomURL(site, url);  
  },

  showCustomIconFileDialog : function(e)
  {
    var siteId = sitelauncherPrefs.selectedShortcutId;
    if(siteId === null)
    {
      return;
    }    

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    fileChooser.appendFilters(nsIFilePicker.filterImages);
    fileChooser.init(window, sitelauncherUtilsMisc.getLocaleString("selectImage"), nsIFilePicker.modeOpen);

    if(fileChooser.show() === nsIFilePicker.returnOK)
    {
      var file = fileChooser.file;
      var validTypes = ['image/gif', 'image/x-icon', 'image/jpeg', 'image/pjpeg', 'image/png'];
      var dataURL = sitelauncherUtilsFile.fileToDataURL(file, validTypes);
      
      if(dataURL !== null)
      {
        var site = sitelauncher.getSiteById(siteId);
        if(site === null)
        {
          return;
        }
          
        sitelauncherSiteIcons.backupOriginalIconData(site);
        sitelauncherSiteIcons.insertSiteIconsFromDataURL(site, dataURL);
      }
      else
      {
        var prompts = Components.classes['@mozilla.org/embedcomp/prompt-service;1'].getService(Components.interfaces.nsIPromptService);
        prompts.alert(null, '', sitelauncherUtilsMisc.getLocaleString("invalidFile"));
      }     
    }
  },

  restoreOriginalSiteIcon : function()
  {
    var siteId = sitelauncherPrefs.selectedShortcutId;
    if(siteId !== null)
    {
      var site = sitelauncher.getSiteById(siteId);
      if(site === null)
      {
        return;
      }
      sitelauncherSiteIcons.restoreOriginalIconData(site);
    }    
  },

  populateNonStaticHotkeyLabels : function()
  {
    // launcher hotkey

    var keys = [sitelauncher.getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.secondary'),
                sitelauncher.getIntPref('extensions.sitelauncher.launcher.shortcut.modifiers.primary')];
    var launcherHotkeyText = sitelauncherUtilsMisc.getKeyComboAsLocaleText(keys);

    document.getElementById("sitelauncherHotkeyLauncherLabel").setAttribute("value", launcherHotkeyText);

    // direct hotkey

    keys = [sitelauncher.getIntPref('extensions.sitelauncher.shortcut.modifiers.secondary'),
            sitelauncher.getIntPref('extensions.sitelauncher.shortcut.modifiers.primary')];
    var directHotkeyText = sitelauncherUtilsMisc.getKeyComboAsLocaleText(keys);

    document.getElementById("sitelauncherHotkeyDirectLabel").setAttribute("value", directHotkeyText);
  },

  compactViewIfNeeded : function()
  {
    var h = window.screen.availHeight;
    
    if(h < 700)
    {
      document.getElementById("sitelauncherPrefWindow").setAttribute("__compactView", "true", null);
    }
  },

  updateSort : function()
  {
    sitelauncherPrefs.targetGroup = null;
    sitelauncher.sort(parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10));
    sitelauncherPrefs.drawAndKeepSelected();
    sitelauncherPrefs.assertChangesPending();  
  },
        
  drawItem : function(site)
  {
    var listitem = document.createElement('richlistitem');
    listitem.setAttribute('__slItemId', site.id);
    listitem.setAttribute('__sitelauncherItemType', 'shortcut');    
    listitem.setAttribute('__sitelauncherItemGroup', site.groupId);
    listitem.setAttribute('value', site.key);
    listitem.setAttribute('align', 'center');
    listitem.addEventListener('mousedown', function(e){sitelauncherPrefs.startDrag(e);}, false);
    
    var iconBox = document.createElement('hbox');
    iconBox.setAttribute('class', 'sitelauncherIconBackground')
    var img = document.createElement('box');
    img.setAttribute('class', 'sitelauncherIcon');
    img.setAttribute('width', '16px');
    img.setAttribute('height', '16px');
    
    // older sl schema doesn't have smaller icons, so resize medium one instead
    if(sitelauncher.shortcutSchemaVersion === 1)
    {
     img.style.setProperty('background-image', 'url("' + site.iconData + '")', null);
     img.style.setProperty('background-size', '16px 24px', null);
    }
    else
    {
      img.style.setProperty('background-image', 'url("' + site.iconDataSmall + '")', null);
    }
    
    iconBox.appendChild(img);     
    listitem.appendChild(iconBox);

    var titleBox = document.createElement("hbox");
    var label = document.createElement('label');
    titleBox.setAttribute("class", "sitelauncherListItemTitleBox");
    label = document.createElement('label');
    label.setAttribute("class", "sitelauncherListItemTitle");
    label.appendChild(document.createTextNode(site.title));
    titleBox.appendChild(label);
    listitem.appendChild(titleBox);
    
    label = document.createElement('label');    
    label.appendChild(document.createTextNode(site.key));
    label.setAttribute('class', 'sitelauncherListItemKey');
    listitem.appendChild(label);    

    var spacer = document.createElement('spacer');
    spacer.setAttribute('flex', '1');
    listitem.appendChild(spacer);

    var box = document.createElement('box');
    box.setAttribute('class', 'sitelauncherClose');
    box.addEventListener('click', 
      function(e){sitelauncherPrefs.remove(this.parentNode.getAttribute("__slItemId"))}, false);
    box.setAttribute('tooltiptext', sitelauncherUtilsMisc.getLocaleString("delete"));
    listitem.appendChild(box); 

    sitelauncherPrefs.nodes.richListBox.appendChild(listitem);
  },
  
  drawGroupItem : function(group)
  {
    var listitem = document.createElement('richlistitem');
    listitem.setAttribute('__sitelauncherItemType', 'group');    
    listitem.setAttribute('__sitelauncherGroup', group.id);
    listitem.setAttribute('align', 'stretch');
    listitem.setAttribute('orient', 'vertical');
    listitem.addEventListener('mousedown', function(e){sitelauncherPrefs.startDrag(e);}, false);    
    
    var groupLength = sitelauncher.getSitesByGroup(group.id).length;
    
    if(groupLength > 0)
    {
      listitem.setAttribute('__sitelauncherGroupIsEmpty', 'false');
    }
    else
    {
      listitem.setAttribute('__sitelauncherGroupIsEmpty', 'true');
    }
    var hbox = document.createElement('hbox');
    
    var titleBox = document.createElement("hbox");    
    titleBox.setAttribute("class", "sitelauncherListItemTitleBox");    
    var label = document.createElement('label');
    label.setAttribute("class", "sitelauncherListItemTitle");    
    label.appendChild(document.createTextNode(group.title));
    titleBox.appendChild(label);

    if(group.id === 0)
    {
      label = document.createElement('label');
      label.style.setProperty('opacity', '.5', null);
      label.style.setProperty('margin-left', '1em', null);
      label.appendChild(document.createTextNode(sitelauncherUtilsMisc.getLocaleString("mainGroupBracketed")));
      titleBox.appendChild(label);
    }

    hbox.appendChild(titleBox);

    var spacer = document.createElement('spacer');
    spacer.setAttribute('flex', '1');
    hbox.appendChild(spacer);
  
    var box = document.createElement('box');
    box.setAttribute('class', 'sitelauncherClose');    
    box.addEventListener('click', function(e){
      sitelauncherPrefs.removeGroup(parseInt(this.parentNode.parentNode.getAttribute("__sitelauncherGroup")), 10);}, false);
    
    if(groupLength > 0)
    {
      box.setAttribute('tooltiptext', sitelauncherUtilsMisc.getLocaleString("deleteGroupAndContents"));
    }
    else
    {
      box.setAttribute('tooltiptext', sitelauncherUtilsMisc.getLocaleString("delete"));
    }
    
    hbox.appendChild(box); 
    listitem.appendChild(hbox);
    
    box =  document.createElement('box');
    box.setAttribute('class', 'sitelauncherEmptyGroupLabel');
    label = document.createElement('label');
    label.setAttribute('value', sitelauncherUtilsMisc.getLocaleString("dropShortcutsHere"));
    box.appendChild(label);
    listitem.appendChild(box);

    sitelauncherPrefs.nodes.richListBox.appendChild(listitem);
  },
        
  drawAndKeepSelected : function()
  {
    var selected = sitelauncherPrefs.nodes.richListBox.selectedItem;

    var type = selected ? selected.getAttribute('__sitelauncherItemType') : null;
    var item;

    if(type === 'shortcut')
    {
      item = sitelauncherPrefs.getSiteByElement(selected);
    }
    else if(type === 'group')
    {
      item = sitelauncherPrefs.getGroupByElement(selected);
    }
    
    sitelauncherPrefs.draw();
    
    if(!item)
    {
      return;
    }

    var elm;

    if(type === 'shortcut')
    {
      elm = sitelauncherPrefs.getSiteRichListItemById(item.id);
    }
    else if(type === 'group')
    {
      elm = sitelauncherPrefs.getGroupListItemById(item.id);
    }      
    
    if(!elm)
    {
      return;
    }      
    
    sitelauncherPrefs.nodes.richListBox.selectedItem = elm;
  },
        
  draw : function()
  {
    var list = sitelauncherPrefs.nodes.richListBox;
    sitelauncherUtilsDom.deleteAllChildNodes(list);
    
    if(!sitelauncherPrefs.showGroups)
    {
      for(var x = 0; x < sitelauncher.sites.length; x++)
      {
        sitelauncherPrefs.drawItem(sitelauncher.sites[x]);
      }
    }    
    else
    {
      var groups = sitelauncher.groups;
         
      for(var x = 0; x < groups.length; x++)
      {
        sitelauncherPrefs.drawGroupItem(groups[x]);
  
        for(var i = 0; i < sitelauncher.sites.length; i++)
        {
          if(sitelauncher.sites[i].groupId === groups[x].id)
            sitelauncherPrefs.drawItem(sitelauncher.sites[i]);
        }          
      }
    }
    
    // auto select first item
    var firstItem = sitelauncherPrefs.nodes.richListBox.getItemAtIndex(0);
    if(firstItem !== null)
    {
      sitelauncherPrefs.nodes.richListBox.selectedItem = firstItem;
    }
  },

  dragStartScreenX : null,
  dragStartScreenY : null,

  dragSrcItem : null,
  dragSrcItemType : null,
  dragSrcItemData : null,
  
  dragCurrentTarget : null,
  dragCurrentTargetType : null,
  dragCurrentTargetData : null,

  dragGestured : false,
  dragScrollIntervalId : null,
  dragScrollDirection : null,
  
  dragOutOfBounds : null,
  
  dragGroupOffset : null,  

  startDrag : function(e)
  {
    if(e.button !== 0)
    {
      return;
    }

    var item = e.currentTarget;
    
    sitelauncherPrefs.dragStartScreenX = e.screenX;
    
    sitelauncherPrefs.dragSrcItem = item;
    sitelauncherPrefs.dragSrcItemType = item.getAttribute('__sitelauncherItemType');
    
    if(sitelauncherPrefs.dragSrcItemType === 'shortcut')
    {
      sitelauncherPrefs.dragSrcItemData = sitelauncherPrefs.getSiteByElement(item);    
    }
    else
    {
      sitelauncherPrefs.dragSrcItemData = sitelauncherPrefs.getGroupByElement(item);
    }
    
    sitelauncherPrefs.dragGestured = false;
    sitelauncherPrefs.dragCurrentTarget = null;
    sitelauncherPrefs.dragScrollDirection = null;
    sitelauncherPrefs.dragGroupOffset = null;
    sitelauncherPrefs.dragOutOfBounds = false;
    
    //sitelauncherPrefs.nodes.shortcutGroupbox.
    //  addEventListener('mousemove', sitelauncherPrefs.updateDrag, true);

    sitelauncherPrefs.nodes.managePane.
      addEventListener('mousemove', sitelauncherPrefs.updateDrag, true);              
       
    document.documentElement.
      addEventListener('mouseup', sitelauncherPrefs.dropDrag, true);
         
    document.documentElement.
      addEventListener('mouseover', sitelauncherPrefs.dragScroll, true);   
  },
  
  updateDrag : function(e)
  {
    if(!sitelauncherPrefs.dragGestured && Math.abs(sitelauncherPrefs.dragStartScreenX - e.screenX) < 3)
    {
      return;
    }
    
    // just in case clean up didn't occur for some reason
    if(sitelauncherPrefs.dragSrcItem === null)
    {
      sitelauncherPrefs.dragCleanup();
      return;   
    }   

    var item = e.originalTarget;

    if(item.tagName !== 'richlistitem')
    {
      for(var x = 0; x < 5; x++)
      {
        item = item.parentNode;
        if(item.tagName === 'richlistitem')
        {
          break;
        }
      }
    }
    
    sitelauncherPrefs.dragGestured = true;
    
    if(item && item.tagName === 'richlistitem')
    {
      sitelauncherPrefs.dragScrollBreak();

      // make drag to top hotspot
      var offset = {};
      sitelauncherPrefs.nodes.richListBox.scrollBoxObject.getPosition({}, offset);

      if(e.screenY - sitelauncherPrefs.nodes.richListBox.boxObject.screenY < 15 &&
         offset.value < 3)
      {
        sitelauncherPrefs.dragSetTargetItem(item, true);
      }
      else
      {
        sitelauncherPrefs.dragSetTargetItem(item);
      }
    }
  },
  
  dragScroll : function(e)
  {

    if(sitelauncherPrefs.dragSrcItem === null || e.target.tagName === 'prefpane')
    {
      sitelauncherPrefs.dragCleanup();
      return;   
    }       
    
    // mouse moved
    sitelauncherPrefs.dragGestured = true; 

    if(e.screenY <= sitelauncherPrefs.nodes.richListBox.boxObject.screenY)
    {
      sitelauncherPrefs.dragOutOfBounds = true;
      sitelauncherPrefs.dragClearTargetIndicator();
      sitelauncherPrefs.dragChangeCursor('denied');
      
      sitelauncherPrefs.dragScrollDirection = -1;
      if(sitelauncherPrefs.dragScrollIntervalId === null)
      {
        sitelauncherPrefs.dragScrollIntervalId = 
          setInterval /* referencing function */ (sitelauncherPrefs.dragScrollRepeat, 75);
      }
      return;
    }
    else if(e.screenY >= sitelauncherPrefs.nodes.richListBox.boxObject.screenY + 
            sitelauncherPrefs.nodes.richListBox.boxObject.height)
    {
      sitelauncherPrefs.dragOutOfBounds = true;      
      sitelauncherPrefs.dragClearTargetIndicator();      
      sitelauncherPrefs.dragChangeCursor('denied');      
      
      sitelauncherPrefs.dragScrollDirection = 1;
      if(sitelauncherPrefs.dragScrollIntervalId === null)
      {
        sitelauncherPrefs.dragScrollIntervalId = 
          setInterval /* referencing function */ (sitelauncherPrefs.dragScrollRepeat, 75);
      }
      return;
    }
    else
    {
      sitelauncherPrefs.dragOutOfBounds = false;      
      sitelauncherPrefs.dragScrollDirection = null;
    }
  },
  
  dragCleanup : function(e)
  {
    sitelauncherPrefs.dragScrollBreak();
    sitelauncherPrefs.dragClearTargetIndicator(); 
    
    sitelauncherPrefs.nodes.managePane.
      removeEventListener('mousemove', sitelauncherPrefs.updateDrag, true);    
         
    document.documentElement.
      removeEventListener('mouseup', sitelauncherPrefs.dropDrag, true);
      
    document.documentElement.
      removeEventListener('mouseover', sitelauncherPrefs.dragScroll, true);        
      
    sitelauncherPrefs.dragStartScreenX = null;
      
    sitelauncherPrefs.dragSrcItem = null;
    sitelauncherPrefs.dragSrcItemType = null;
    sitelauncherPrefs.dragSrcItemData = null;

    sitelauncherPrefs.dragCurrentTarget = null;
    sitelauncherPrefs.dragCurrentTargetType = null;
    sitelauncherPrefs.dragCurrentTargetData = null;
    
    sitelauncherPrefs.dragGestured = false;
    sitelauncherPrefs.dragScrollDirection = null;
    
    sitelauncherPrefs.dragGroupOffset = null;
    
    sitelauncherPrefs.dragOutOfBounds = null;

    // revert mouse cursor
    sitelauncherPrefs.nodes.managePane.setAttribute('__slCursor', '');
  },
  
  dragClearTargetIndicator : function()
  {
    var listitems = sitelauncherPrefs.nodes.richListBox.getElementsByTagName('richlistitem');
    for(var x = 0; x < listitems.length; x++)
    {
      listitems[x].setAttribute('class', '');
    }        
  },
  
  dragHighlightGroup : function(groupId)
  {
     sitelauncherPrefs.dragChangeCursor('drop');
        
     // highlight items in group
     var items = document.getElementsByAttribute('__sitelauncherItemGroup', groupId);
     for(var x = 0; x < items.length; x++)
     {
       items[x].setAttribute('class', 'partOfDropGroup');
     }
     
     if(items && items.length)
     {
       items[items.length - 1].setAttribute('class', 'partOfDropGroup bottomPartOfDropGroup');         
     }
     
     // highlight group header
     var headers = document.getElementsByAttribute('__sitelauncherGroup', groupId);
     if(headers && headers.length)
     {
       headers[0].setAttribute('class', 'headerOfDropGroup');
     }
     else
     {
       if(items && items.length)
       {
         items[0].setAttribute('class', items[0].getAttribute('class') + ' topPartOfDropGroup');
       }
     }
  },
  
  dragChangeCursor : function(cursorTypeStr)
  {
    var cursorClass = sitelauncherPrefs.nodes.managePane.getAttribute('__slCursor');
    if(cursorClass === cursorTypeStr + 'CursorShown')
    {
      return;
    }
    
    sitelauncherPrefs.nodes.managePane.setAttribute('__slCursor', cursorTypeStr + 'CursorShown');
  },
  
  dragSetTargetItem : function(item, before)
  {
    sitelauncherPrefs.dragClearTargetIndicator(); 
    
    var single = true;
    
    sitelauncherPrefs.dragCurrentTarget = item;

    // return if out of bounds as we only use for scrolling, rest is n/a
    if(sitelauncherPrefs.dragOutOfBounds)
    {
      sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(item); 
      return;
    }

    sitelauncherPrefs.dragCurrentTargetType = item.getAttribute('__sitelauncherItemType');
    sitelauncherPrefs.dragCurrentTargetData = sitelauncherPrefs.dragCurrentTargetType === 'shortcut' ?
      sitelauncherPrefs.getSiteByElement(item) : sitelauncherPrefs.getGroupByElement(item);     
    
    // dragging shortcut
    if(sitelauncherPrefs.dragSrcItemType === 'shortcut')
    {
      sitelauncherPrefs.dragChangeCursor('drag');
      
      var sortBy = parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10); 
      if(sitelauncherPrefs.showGroups && sortBy !== 0)
      {
         if(item.getAttribute('__sitelauncherItemType') === 'shortcut')
         {
           var targetSite = sitelauncherPrefs.getSiteByElement(item);
           var groupId = targetSite.groupId;
         }
         else
         {
           var targetGroup = sitelauncherPrefs.getGroupByElement(item);
           var groupId = targetGroup.id;         
         }
         
         // if sort by auto, then user can only drag to diff group
         if(sitelauncherPrefs.dragSrcItemData.groupId !==  groupId)
         {
           single = false;
           sitelauncherPrefs.dragHighlightGroup(groupId);
         }
      }
    }
    // dragging group
    else
    {
      var nextItem = sitelauncherPrefs.dragCurrentTarget.nextSibling;
      var nextItemType;
      if(nextItem)
      {
        nextItemType = nextItem.getAttribute('__sitelauncherItemType');
      }
      
      // top item is group, and dragging to above it
      if(before && sitelauncherPrefs.dragCurrentTargetType === 'group' &&
         sitelauncherPrefs.dragSrcItemData.id !== sitelauncherPrefs.dragCurrentTargetData.id)
      {
        sitelauncherPrefs.dragChangeCursor('group');         
        sitelauncherPrefs.dragGroupOffset = -1;
      }
      // dragging to below empty group
      else if(!before && sitelauncherPrefs.dragCurrentTargetType === 'group' && 
         item.getAttribute('__sitelauncherGroupIsEmpty') === 'true' &&
         sitelauncherPrefs.dragSrcItemData.id !== sitelauncherPrefs.dragCurrentTargetData.id)
      {
        sitelauncherPrefs.dragChangeCursor('group');
        sitelauncherPrefs.dragGroupOffset = sitelauncherPrefs.dragCurrentTargetData.id;
      }
      // dragging to last shortcut in diff group (i.e. drop is under diff group)  
      else if(!before && sitelauncherPrefs.dragCurrentTargetType === 'shortcut' &&
              sitelauncherPrefs.dragCurrentTargetData.groupId !== sitelauncherPrefs.dragSrcItemData.id &&
              nextItemType !== 'shortcut')
      {
        sitelauncherPrefs.dragChangeCursor('group');
        sitelauncherPrefs.dragGroupOffset = sitelauncherPrefs.dragCurrentTargetData.groupId;        
         
      }   
      // dragging to none droppable item 
      else
      {
        sitelauncherPrefs.dragGroupOffset = null;
        sitelauncherPrefs.dragChangeCursor('denied');
     
      }
    }
    
    if(before && single)
    {
      item.setAttribute('class', 'sitelauncherDropIndicatorFirst');      
    }
    // after (default)
    else if(single)
    {
      // don't indicate drop to self (shortcut)
      if(sitelauncherPrefs.dragCurrentTargetType === 'shortcut' && 
         sitelauncherPrefs.dragCurrentTargetData.id === sitelauncherPrefs.dragSrcItemData.id)
      {
        return;
      }

      item.setAttribute('class', 'sitelauncherDropIndicator');
    }
    
    sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(item); 
  },
  
  dragScrollRepeat : function(e)
  {
    if(!sitelauncherPrefs.dragGestured  ||
       sitelauncherPrefs.dragSrcItem === null || 
       sitelauncherPrefs.dragScrollIntervalId === null || 
       sitelauncherPrefs.dragScrollDirection === null)
    {
      clearInterval(sitelauncherPrefs.dragScrollIntervalId);
      sitelauncherPrefs.dragLastScrollItem = null;
      sitelauncherPrefs.dragScrollDirection === null;
      return;
    }    
    
    var listitems = sitelauncherPrefs.nodes.richListBox.getElementsByTagName('richlistitem');
    var first = sitelauncherPrefs.nodes.richListBox.getIndexOfItem(sitelauncherPrefs.dragCurrentTarget);

    // scroll up
    if(sitelauncherPrefs.dragScrollDirection === -1)
    {
      if(first > 0)
      { 
        sitelauncherPrefs.dragSetTargetItem(listitems[first - 1]);
      }
      // indicating very top pos
      else if(first === 0)
      {
        sitelauncherPrefs.dragSetTargetItem(listitems[0]); 
        sitelauncherPrefs.dragScrollBreak(); // can't go any further
      }
    }
    // scroll down
    else if(sitelauncherPrefs.dragScrollDirection === 1)
    {
      if(sitelauncherPrefs.dragCurrentTarget === null)
        return;
      
      var i = first;

      if(i > -1 && i < sitelauncherPrefs.nodes.richListBox.childNodes.length - 1)
      {
        sitelauncherPrefs.dragSetTargetItem(listitems[i + 1]);
      }
    }
  },
  
  dragScrollBreak : function()
  {
    sitelauncherPrefs.dragScrollDirection = null;

    if(sitelauncherPrefs.dragScrollIntervalId === null)
      return;
      
    clearInterval(sitelauncherPrefs.dragScrollIntervalId);
    sitelauncherPrefs.dragScrollIntervalId = null;
  },  
  
  dropDrag : function(e)
  {
    if(e.button !== 0)
    {
      return;
    }

    if(!sitelauncherPrefs.dragGestured || sitelauncherPrefs.dragCurrentTarget === null ||
       sitelauncherPrefs.dragSrcItem === null)
    {
      sitelauncherPrefs.dragCleanup();
      return;
    }
    
    e.preventDefault();    
    e.stopPropagation();
    
    sitelauncherPrefs.nodes.managePane.
      removeEventListener('mousemove', sitelauncherPrefs.updateDrag, true);     
         
    document.documentElement.
      removeEventListener('mouseup', sitelauncherPrefs.dropDrag, true);
      
    document.documentElement.
      removeEventListener('mouseover', sitelauncherPrefs.dragScroll, true);  
      

    if(sitelauncherPrefs.dragOutOfBounds)
    {
      sitelauncherPrefs.dragClearTargetIndicator();
      sitelauncherPrefs.dragCleanup();      
      return;
    }

    var srcItem = sitelauncherPrefs.dragSrcItem;
    var srcIsGroup  = sitelauncherPrefs.dragSrcItemType === 'group';
    var srcData = sitelauncherPrefs.dragSrcItemData;
    var srcItemType = sitelauncherPrefs.dragSrcItemType;
    
    var targetItem = sitelauncherPrefs.dragCurrentTarget;
    var targetIsGroup = sitelauncherPrefs.dragCurrentTargetType === 'group';
    var targetItemClass = targetItem.getAttribute('class');    
    var targetData = sitelauncherPrefs.dragCurrentTargetData;
    var targetGroup = targetIsGroup ? targetData.id : targetData.groupId;
    
    var dragOffset = sitelauncherPrefs.dragGroupOffset;                              
    var sortBy = parseInt(sitelauncherPrefs.nodes.sortByMenuList.value, 10);                                        
    var moveTo;    
    
    var blocked = false;


    // clear target indicator
    sitelauncherPrefs.dragClearTargetIndicator();
    
    sitelauncherPrefs.dragCleanup();

    // move group
    if(srcIsGroup)
    {
      if(dragOffset !== null)
      {
        sitelauncher.moveGroupToAfter(srcData.id, dragOffset);
      }
      else
      {
        return;
      }
    }
    // move shortcut
    else
    {
      // move item to top of target group
      if(targetItemClass === 'sitelauncherDropIndicatorFirst' || targetIsGroup)
      {
        moveTo = -1;
        
        // outside target
        if(targetItemClass === 'sitelauncherDropIndicatorFirst')
        {
          targetGroup = 0;
        }
      }
      // move to below target item
      else
      {
        moveTo = targetData.id;
      }
      
      // let user know if blocked due to auto sort
      if(sortBy !== 0 && (srcData.groupId === targetGroup || !sitelauncherPrefs.showGroups ) && 
         targetData.id !== srcData.id)
      {
        // show message only if order would have actually changed
        var itemAbove = srcItem.previousSibling;
        if(!(itemAbove && itemAbove.isSameNode(targetItem)) || 
           targetItemClass === 'sitelauncherDropIndicatorFirst')
        {
          sitelauncherPrefs.showSortDeniedIcon();
          blocked = true;
        }
      }
      
      // apply move item changes
      if(sitelauncherPrefs.showGroups && srcData.groupId !== targetGroup)
      {
        sitelauncher.changeGroupById(srcData.id, targetGroup);
      }
    
      if(!blocked)
      {
        sitelauncher.moveToAfterById(srcData.id, moveTo)
      }
    }
    
    if(blocked)
    {
      return;
    }
    
    sitelauncher.sort(sortBy);
    sitelauncherPrefs.draw();
      
    // select newly moved item, don't bother with group--too jarring
    if(srcItemType !== 'group')
    {
      var newItem = sitelauncherPrefs.selectSiteListItem(srcData.id);
      sitelauncherPrefs.nodes.richListBox.ensureElementIsVisible(newItem);
    } 
      
    sitelauncherPrefs.assertChangesPending();      
  },

  openURIInBrowserWindow : function(uri)
  {
    var w = Components.classes["@mozilla.org/appshell/window-mediator;1"]
              .getService(Components.interfaces.nsIWindowMediator);
    var b = w.getMostRecentWindow("navigator:browser");
    
    if(b)
    {
      b.open(uri, '', '');
    } 
  },
  
  showLauncherInBrowserWindow : function()
  {
    var w = Components.classes["@mozilla.org/appshell/window-mediator;1"]
              .getService(Components.interfaces.nsIWindowMediator);
    var b = w.getMostRecentWindow("navigator:browser");
    
    if(b)
    {
      b.sitelauncherLauncher.invokeLauncherMode();
    } 
  },

  showGroupingUI : function()
  {
    sitelauncherPrefs.showGroups = true;
    sitelauncherPrefs.enableFeatureUI("groups");
  },
  
  hideGroupingUI : function()
  {
    sitelauncherPrefs.showGroups = false; 
    sitelauncherPrefs.disableFeatureUI("groups");
  },
  
  enableFeatureUI : function(featureName)
  {
    var enabledFeatures = "";
    var enabledFeatAttr = "__sitelauncherEnabledFeatures";
    var prefManagePane = document.getElementById('sitelauncherPrefPaneManage');
    var prefOptionsPane = document.getElementById('sitelauncherPrefPaneOptions');

    if(prefManagePane.hasAttribute(enabledFeatAttr))
    {
      enabledFeatures = prefManagePane.getAttribute(enabledFeatAttr);
    }
        
    if(enabledFeatures.indexOf(featureName) === -1)
    {
      enabledFeatures += " " + featureName;
      prefManagePane.setAttribute(enabledFeatAttr, enabledFeatures);
      prefOptionsPane.setAttribute(enabledFeatAttr, enabledFeatures);
    }
  },
  
  disableFeatureUI : function(featureName)
  {
    var enabledFeatAttr = "__sitelauncherEnabledFeatures";
    var prefManagePane = document.getElementById('sitelauncherPrefPaneManage');
    var prefOptionsPane = document.getElementById('sitelauncherPrefPaneOptions');

    if(prefManagePane.hasAttribute(enabledFeatAttr))
    {
      var enabledFeatures = prefManagePane.getAttribute(enabledFeatAttr).replace(" " + featureName, "");
      prefManagePane.setAttribute(enabledFeatAttr, enabledFeatures);
      prefOptionsPane.setAttribute(enabledFeatAttr, enabledFeatures);  
    }
  },
  
  showCustomIconsUI : function()
  {
    sitelauncherPrefs.showCustomIconsFeature = true;
    sitelauncherPrefs.showCustomIconButtonIfApplicable();         
  },
  
  hideCustomIconsUI : function()
  {
    sitelauncherPrefs.showCustomIconsFeature = false;
    sitelauncherPrefs.showCustomIconButtonIfApplicable();      
  },
  
  showCustomIconButtonIfApplicable : function()
  {
    if(sitelauncherPrefs.showCustomIconsFeature &&
       sitelauncherPrefs.selectedItemType === sitelauncherPrefs.itemTypes.shortcut) 
    {
      if(!sitelauncherPrefs.customIconButtonShowing)
      {
        sitelauncherPrefs.customIconButtonShowing = true;
        sitelauncherPrefs.nodes.customIconButton.style.setProperty('visibility', 'visible', null);
      }
    }
    else
    {
      if(sitelauncherPrefs.customIconButtonShowing)
      {
        sitelauncherPrefs.customIconButtonShowing = false;
        sitelauncherPrefs.nodes.customIconButton.style.setProperty('visibility', 'hidden', null);
      }
    }
  },
  
  getTargetGroup : function()
  {
    return sitelauncherPrefs.targetGroup;
  },
  
  isShortcutInEditBoxUnique : function()
  {
    var key = sitelauncherPrefs.nodes.textBoxKey.value;
    var url = sitelauncherPrefs.nodes.textBoxUrl.value;
    
    return !sitelauncher.getSiteByKey(key) && !sitelauncher.getSiteByUrl(url);
  },
  
  showSortDeniedIcon : function()
  {
    if(sitelauncherPrefs.sortDeniedIconShowing)
    {
      return;
    }
    
    sitelauncherPrefs.sortDeniedIconShowing = true;
    
    var image = document.getElementById("sitelauncherSortDeniedIndicator");
    
    fadeIconIn(0);
    function fadeIconIn(x)
    {
      image.style.setProperty('-moz-opacity', x, null);

      if(x === 0)
      {
        image.style.setProperty('visibility', 'visible', null);
      }
      else if(x > .9)
      {
        setTimeout(function(){fadeIconOut(1)}, 2000);
        return;
      }

      setTimeout(function(){fadeIconIn(x + .5)}, 10);
    }
    
    function fadeIconOut(x)
    {
      if(x < 0)
      {
        image.style.setProperty('visibility', 'hidden', null);
        sitelauncherPrefs.sortDeniedIconShowing = false;
        return;
      }

      image.style.setProperty('-moz-opacity', x, null);

      setTimeout(function(){fadeIconOut(x - .2)}, 10);
    }
  },

  message : function(text, icon)
  {
    if(sitelauncherPrefs.messageBeingShown)
    {
      return;
    }
    
    sitelauncherPrefs.messageBeingShown = true;
    
    var box = document.getElementById("sitelauncherPrefsMessageBox");
    var image = document.getElementById("sitelauncherPrefsMessageImage");
    var label = document.getElementById("sitelauncherPrefsMessageLabel");
    
    if(icon)
    {
      image.setAttribute('src', 'chrome://sitelauncher/content/icons/' + icon);
    }
    
    label.setAttribute('value', text);
    
    fadeIn(0);
    function fadeIn(x)
    {
      box.style.setProperty('-moz-opacity', x, null);

      if(x === 0)
      {
        box.style.setProperty('visibility', '', null);
      }
      else if(x > .9)
      {
        setTimeout(function(){fadeOut(1)}, 2000);
        return;
      }

      setTimeout(function(){fadeIn(x + .5)}, 10);
    }
    
    function fadeOut(x)
    {
      if(x < 0)
      {
        box.style.setProperty('visibility', 'hidden', null);
        sitelauncherPrefs.messageBeingShown = false;
        return;
      }

      box.style.setProperty('-moz-opacity', x, null);

      setTimeout(function(){fadeOut(x - .2)}, 10);
    }
  },
  
  indicatorBeingShown : false,
  indicatorShow : function(icon, text)
  {
    sitelauncherPrefs.indicatorBeingShown = true;
    
    var box = document.getElementById("sitelauncherPrefsMessageBox");
    var image = document.getElementById("sitelauncherPrefsMessageImage");
    var label = document.getElementById("sitelauncherPrefsMessageLabel");
    
    var w = box.boxObject.width;
    w = box.style.setProperty('max-width', w + 'px', null);
    
    if(text)
    {
      label.setAttribute('value', text);
    }
    else
    {
      image.setAttribute("value", "");
    }    
    
    if(icon)
    {
      image.setAttribute('src', 'chrome://sitelauncher/content/icons/' + icon);
    }
    else
    {
      image.setAttribute("src", "");
    }
    
    box.style.setProperty('visibility', 'visible', null);
    box.style.setProperty('opacity', 1, null);
  },
  
  indicatorHide : function()
  {
    sitelauncherPrefs.indicatorBeingShown = false;
    var box = document.getElementById("sitelauncherPrefsMessageBox");
    box.style.setProperty('visibility', 'hidden', null);
  },

  handleSiteListShortcut : function(e)
  {
    if(document.commandDispatcher.focusedElement.tagName !== 'richlistbox' &&
       document.commandDispatcher.focusedElement.tagName !== 'richlistitem')
    {
      return;
    }
    
    if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_SPACE)
    {
      e.stopPropagation(); 
      e.preventDefault();
      
      if(sitelauncherPrefs.selectedItemType === sitelauncherPrefs.itemTypes.shortcut) 
      {
        sitelauncherPrefs.showEditShortcutView();
      }
      else if(sitelauncherPrefs.selectedItemType === sitelauncherPrefs.itemTypes.group) 
      {
        sitelauncherPrefs.showEditGroupTitleView();
      }  
    }    
    else if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_RETURN)
    {
      // accept dialog if [ctrl / cmd held down] + enter
      if((!sitelauncherPrefs.isMacPlatform && e.ctrlKey) || 
         (sitelauncherPrefs.isMacPlatform && e.cmdKey))
      {
        document.documentElement.acceptDialog();
        return;
      }

      e.stopPropagation(); 
      e.preventDefault();      
      
      sitelauncherPrefs.showAddNewShortcutForm();
    }  
    else if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_DELETE)
    {
      var item = sitelauncherPrefs.nodes.richListBox.selectedItem;
      if(item)
      {
        if(sitelauncherPrefs.showGroups && item.hasAttribute('__sitelauncherGroup'))
        {
          sitelauncherPrefs.removeGroup(parseInt(item.getAttribute('__sitelauncherGroup'), 10));
        }
        else
        {
          sitelauncherPrefs.remove(item.getAttribute('__slItemId'));
        }
        e.preventDefault();
        e.stopPropagation();
      }
    }    
  },

  resetShortcutListView : function()
  {
    sitelauncherPrefs.updateSort();
    sitelauncherPrefs.clearWithNoFocus();
    sitelauncherPrefs.showDefaultEditView();   
  },

  prefChangeListener : function(name, value)
  {
    switch(name)
    {
      case "extensions.sitelauncher.enableCustomIcons":
        if(value)
        {
          sitelauncherPrefs.showCustomIconsUI();
          sitelauncherPrefs.resetShortcutListView ();   
        }
        else
        {
          sitelauncherPrefs.hideCustomIconsUI();  
          sitelauncherPrefs.resetShortcutListView();             
             
        }
      break;
    
      case "extensions.sitelauncher.grouping":
        if(value)
        {
          sitelauncherPrefs.showGroupingUI();
          sitelauncherPrefs.resetShortcutListView();              
        }
        else
        {
          sitelauncherPrefs.hideGroupingUI();
          sitelauncherPrefs.resetShortcutListView();              
        }      
      break;
    }

  },

  showTextPrompt : function(callback, initialText, buttonLabel, inputLabel)
  {
    sitelauncherPrefs.textPromptShowing = true;

    sitelauncherPrefs.hideAddBackButton();  

    // prevent horizontal collapse
    var w = sitelauncherPrefs.nodes.richListBox.boxObject.width;    
    sitelauncherPrefs.nodes.richListBox.style.setProperty('width', w + 'px', null);
      
    sitelauncherPrefs.textPromptCallbackMethod = callback;
    var box = document.getElementById("sitelauncherTextPromptBox");
    var button = document.getElementById("sitelauncherTextPromptButton");
    var textbox = document.getElementById("sitelauncherTextPromptTextbox");
    
    button.setAttribute('label', buttonLabel);
    textbox.value = initialText;
    
    if(typeof inputLabel !== "undefined") 
    {
      document.getElementById("sitelauncherTextPromptLabel").setAttribute("value", inputLabel);
    }
    else 
    {
      document.getElementById("sitelauncherTextPromptLabel").setAttribute("value", "");
    }
    
    document.getElementById('sitelauncherItemEditBoxesBox').style.setProperty('display', 'none', null);    
    box.style.setProperty('display', '-moz-box', null);
    
    textbox.select();
  },
  
  closeTextPrompt : function()
  {
    if(sitelauncherPrefs.textPromptShowing === true) 
    {
      document.getElementById("sitelauncherTextPromptBox").style.setProperty('display', 'none', null);
      document.getElementById('sitelauncherItemEditBoxesBox').style.setProperty('display', '-moz-box', null);
      sitelauncherPrefs.textPromptShowing = false; 
    }
  },
  
  handleTextPromptKeydown : function(e)
  {
    if(e.keyCode === Components.interfaces.nsIDOMKeyEvent.DOM_VK_RETURN)
    {
      // accept dialog if [ctrl / cmd held down] + enter
      if((!sitelauncherPrefs.isMacPlatform && e.ctrlKey) || 
         (sitelauncherPrefs.isMacPlatform && e.cmdKey))
      {
        document.documentElement.acceptDialog();
        return;
      }

      e.preventDefault();
      e.stopPropagation();
      sitelauncherPrefs.handleTextPromptCallback();
    }
  },  
  
  handleTextPromptCallback : function(e)
  {
    sitelauncherPrefs.closeTextPrompt();
      
    if(sitelauncherPrefs.textPromptCallbackMethod !== null)
    {
      sitelauncherPrefs.textPromptCallbackMethod(document.getElementById("sitelauncherTextPromptTextbox").value);
    }
  },
  
  editButtonClick : function(e)
  {
    if(sitelauncherPrefs.selectedItemType === sitelauncherPrefs.itemTypes.shortcut)
    {
      sitelauncherPrefs.showEditShortcutView();
    }
    else if(sitelauncherPrefs.selectedItemType === sitelauncherPrefs.itemTypes.group)
    {
      sitelauncherPrefs.showEditGroupTitleView();
    }
  },
  
  showLauncherPreview : function()
  {
    if(sitelauncherPrefs.previewShowing) 
    {
      return; // nothing to be done
    }
    
    var h_pane = document.getElementById("prefPaneOptionsContents").clientHeight;
    var h_content = document.getElementById("prefPaneOptionsInner").clientHeight;
    var h_padding = 25;

    var h_preview = h_pane - (h_content + h_padding);
    
    sitelauncherPrefs.previewShowing = true;
    
    document.getElementById("sitelauncherPreviewGroupbox").style.setProperty("height", h_preview + "px", null);
    document.getElementById("sitelauncherPreviewGroupbox").style.setProperty("min-height", h_preview + "px", null);    
    document.getElementById("sitelauncherPreviewGroupbox").style.setProperty("visibility", "visible", null);

    sitelauncherLauncher.init(); // init preview launcher
  },
  
  toggleOptionsPane : function()
  {
    var pane = document.getElementById('sitelauncherPrefPaneOptions');
    var button = document.getElementById('sitelauncherPrefsOptionsToggle'); 
    
    if(!sitelauncherPrefs.optionsPaneState)
    {    
      button.setAttribute('label', sitelauncherUtilsMisc.getLocaleString("mainOptions"));
      button.setAttribute('image', 'chrome://sitelauncher/content/icons/arrowleft');

      // maintain height
      var height = document.getElementById('sitelauncherPrefOptionsContainer').boxObject.height + 'px';
      document.getElementById('sitelauncherPrefOptionsContainer').style.setProperty('height',  height, null);  
      
      document.getElementById("sitelauncherOptionsSection1").style.setProperty("display", "none", null);

      document.getElementById('sitelauncherPrefsAdvancedOptions').style.setProperty('display', '', null);
      
      sitelauncherPrefs.optionsPaneState = 1;
    }
    else
    {
      button.setAttribute('label', sitelauncherUtilsMisc.getLocaleString("advancedTweaks"));
      button.setAttribute('image', 'chrome://sitelauncher/content/icons/advancedoptions');
      
      document.getElementById("sitelauncherOptionsSection1").style.setProperty("display", "", null);
      document.getElementById('sitelauncherPrefsAdvancedOptions').style.setProperty('display', 'none', null);
      
      sitelauncherPrefs.optionsPaneState = 0;      
    }
  },
  
  saveShortcutDataIfChanged : function(e)
  { 
    if(sitelauncherPrefs.changesMade)
    {
      sitelauncher.save();
    }
  },
  
  _setCurrentEditView : function(new_value)
  { 
    if(sitelauncherPrefs.currentEditView === new_value)
    {
      // return early because we want remember lastEditView that wasn't same type
      return;
    }
    
    sitelauncherPrefs.lastEditView = sitelauncherPrefs.currentEditView;
    sitelauncherPrefs.currentEditView = new_value;
  },
}